#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dc.h>
#include <math.h>
#include <stdlib.h>

#define INTRODUCE_TIME 500
#define SPRITE_SIZE 60
#define INIT_SPRITES 10
#define MAX_SPRITES 12
#define ACTIVE 0
#define DESTROYED 1
#define DYING  2
#define B_Left 538
#define B_Right 730
#define B_Top   294
#define B_Bottom 506

class JTextUtils
{
	public:
		JTextUtils(int H,int V);
		~JTextUtils();
		void Set_Text(char *);
		void Set_Speed(int);
		void Set_HPos(int);
		void Set_VPos(int);
//		void Set_Params(int Speed, int H, int V, TColor*);
		void Set_Color(unsigned char,unsigned char,unsigned char); //RGB
		void Set_Color(TColor);
		void Set_ColorDir(int);
		void Set_JFont(int height, int width, char * name);
		void Set_JDC(TClientDC* JDevice);
//		void Scroll(int sx, int sy); // allows cutomizable direction and speed
		void Scroll(); // standard scroll 1 space X direction
		void Pulsate(BOOL PR,BOOL PG,BOOL PB,BOOL Show);
		BOOL AI_Interface();

	private:
		LOGFONT     			TheFont;
		TClientDC 				*winDC;
		char						JText[80];
		char 						AI_Msg[12][80];
		int 						AI_Clock;
		int 						AI_Intro;
		int 						AI_Line;
		int 						ALen[12];
		int 						APindex;
		int 						ALindex;
		BOOL						AI_Write;
		int 						AI_Fade;
		int 						TLen;
		int       				c_index;
		int       				horiz_pos;
		int 						h_init;
		int       				vert_pos;
		int						v_init;
		int 		 				scroll_speed;
		TColor    				Text_Color;
		TColor					JBlack;
		unsigned char       	VGreen;
		unsigned char 		 	VRed;
		unsigned char 		 	VBlue;
		int 						Color_Direction;
};


JTextUtils::JTextUtils(int H, int V)
{
	int i;
	JText[0] = 0;
	strcpy(JText,"Under MIDNIGHT - By: JEREMY C. WITT");
	for (i=0;i<12;i++)
		AI_Msg[i][0]=0;
	AI_Intro = 15;
	AI_Clock = 0;
	AI_Line = 0;
	AI_Fade=0;
	AI_Write=FALSE;
	strcpy(AI_Msg[0],"Testing AI INTERFACE");
	strcpy(AI_Msg[1],"Activate Neuronic Scan");
	strcpy(AI_Msg[2],"MAX Tolerance 80fm res.");
	strcpy(AI_Msg[3],"Automated Procedure Loaded");
	strcpy(AI_Msg[4],"Scanning............ EOL");
	strcpy(AI_Msg[5],"Bio-Degeneration Detected");
	strcpy(AI_Msg[6],"Cell Structure Mutated");
	strcpy(AI_Msg[7],"Analysis: Process Unavoidable");
	strcpy(AI_Msg[8],"Attempting Regeneration prc5");
	strcpy(AI_Msg[9],"Calculating..........................EOL");
	strcpy(AI_Msg[10],"Regeneration: Unsuccessful");
	strcpy(AI_Msg[11],"Subject is Terminal. EoF");
	for(i=0;i<12;i++)
		ALen[i] = strlen(AI_Msg[i]);
	APindex=0;
	ALindex=0;
	TLen = strlen(JText);
	if (!H)
		h_init=-(6*TLen);
	else
		h_init =H;
	horiz_pos = h_init;
	if (!V)
		v_init=0;
	else
		v_init=V;

	vert_pos = v_init;
	scroll_speed=1;
	Set_Color(0,255,0); //bright green
	JBlack = TColor(0,0,0);
	c_index = 0;
	VGreen = VRed = VBlue = 0;
	Color_Direction=3;
	TheFont.lfHeight = 12;
	TheFont.lfWidth = 6;
	TheFont.lfEscapement = 0;
	TheFont.lfOrientation;
	TheFont.lfWeight = FW_NORMAL;
	TheFont.lfItalic = 0;
	TheFont.lfUnderline = 0;
	TheFont.lfStrikeOut = 0;
	TheFont.lfCharSet = ANSI_CHARSET;
	TheFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
	TheFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	TheFont.lfQuality = PROOF_QUALITY;
	TheFont.lfPitchAndFamily = VARIABLE_PITCH|FF_DECORATIVE;
	strcpy(TheFont.lfFaceName, "Times New Roman");

}

JTextUtils::~JTextUtils()
{
 delete winDC;
}

void JTextUtils::Set_JDC(TClientDC* JDevice)
{
	winDC = JDevice;
	winDC->SetBkMode(TRANSPARENT);
}

void JTextUtils::Pulsate(BOOL PR, BOOL PG, BOOL PB, BOOL Show)
{


	if(PR)
		VRed += (unsigned char) Color_Direction;
	if(PG)
		VGreen += (unsigned char) Color_Direction;
	if (PB)
		VBlue += (unsigned char) Color_Direction;
	if (PG&&(VGreen == 255 || VGreen == 0) ||
		 PR&&(VRed   == 255 || VRed   == 0) ||
		 PB&&(VBlue  == 255 || VBlue  == 0))
		Color_Direction = -Color_Direction;
	Set_Color(VRed,VGreen,VBlue);
	if(Show)
	{
		winDC->SaveDC();
		winDC->SetTextColor(Text_Color);
		TFont* font = new TFont(&TheFont); //Create Font
		winDC->SelectObject(*font);    		//Select Font
		winDC->TextOut(horiz_pos,vert_pos,JText,TLen);	//Output Text
		winDC->RestoreFont();
		winDC->RestoreDC();
		delete font;
	}
}


void JTextUtils::Scroll()
{
  TFont* font = new TFont(&TheFont);
  winDC->SaveDC();
  winDC->SelectObject(*font);
  winDC->SetTextColor(JBlack);
  winDC->TextOut(horiz_pos,vert_pos,JText,TLen);
  winDC->SetTextColor(Text_Color);
  horiz_pos += scroll_speed;
  if(horiz_pos > 800)
	horiz_pos =h_init;
  winDC->TextOut(horiz_pos,vert_pos,JText,TLen);
  winDC->RestoreFont();
  winDC->RestoreDC();
  delete font;
}

BOOL JTextUtils::AI_Interface()
{
 BOOL Fade_Done=FALSE;
 if(++AI_Clock > AI_Intro)
 {
	winDC->SaveDC();
	TFont* font = new TFont(&TheFont);
	winDC->SelectObject(*font);

	if (APindex==ALen[ALindex])
	{
		APindex = 0;
		ALindex++;
		vert_pos += 15;
		AI_Line=0;
	}
	if (ALindex==11)
	{
		ALindex=0;
		vert_pos = v_init;
		AI_Write=TRUE;
	}
	if (AI_Write)
	{
		if (++AI_Fade != 16)
		{

			VGreen = VGreen - 15;
			Set_Color(VRed,VGreen,VBlue);
			winDC->SetTextColor(Text_Color);
			for(int j =0; j<11; j++)
				winDC->TextOut(horiz_pos,15*j+vert_pos,AI_Msg[j],ALen[j]);
		}
		else
		{
			AI_Write=FALSE;
			Fade_Done=TRUE;
			AI_Clock = 0;
			AI_Fade=0;
			VGreen=255;
			Set_Color(VRed,VGreen,VBlue);
		}
	}
	else
	{
		if (++AI_Line > 10)
		{
			winDC->SetTextColor(Text_Color);
			winDC->TextOut(horiz_pos,vert_pos,AI_Msg[ALindex],++APindex);
		}
	}
	winDC->RestoreFont();
	winDC->RestoreDC();
	delete font;
 }
 return Fade_Done;
}

void JTextUtils::Set_JFont(int height, int width, char * name)
{
 TheFont.lfHeight = height;
 TheFont.lfWidth  = width;
 strcpy(TheFont.lfFaceName, name);
}

void JTextUtils::Set_Text(char *thetext)
{
 strcpy(JText,thetext);
 TLen = strlen(JText);
}

void JTextUtils::Set_Speed(int NewSpeed)
{
 scroll_speed = NewSpeed;
}

void JTextUtils::Set_HPos(int H_pos)
{
	horiz_pos = H_pos;
}

void JTextUtils::Set_VPos(int V_pos)
{
	vert_pos = V_pos;
}

void JTextUtils::Set_Color(unsigned char SCR, unsigned char SCG,
									unsigned char SCB)
{
 Text_Color = TColor(SCR,SCG,SCB);
}

void JTextUtils::Set_Color(TColor InColor)
{
	Text_Color = InColor;
}

void JTextUtils::Set_ColorDir(int SCDirection)
{
	Color_Direction  = SCDirection;
}


//********************************************************************


const TColor Colors[17]={ 0x00FF0000l, 0x00FF1000l, 0x00FF2000l,
								  0x00FF3000l, 0x00FF4000l, 0x00FF5000l,
								  0x00FF6000l, 0x00FF7000l, 0x00FF8000l,
								  0x00FF9000l, 0x00FFA000l, 0x00FFB000l,
								  0x00FFC000l, 0x00FFD000l, 0x00FFE000l,
								  0x00FFF000l, 0x00FFFF00l};

class TJScrWindow : public TFrameWindow
{
	public:
		TJScrWindow(TWindow* parent, const char far *title);
		~TJScrWindow();
		LOGPALETTE*	MyLogPalette;
		BOOL PalDevice;

	protected:
		void SetupWindow();
		int Timer;
		int Intro_Timer;
		void EvTimer(UINT);
		void EvLButtonDown(UINT,TPoint&);
//		void EvRButtonDown(UINT,TPoint&);
//		void EvMouseMove()
//		void EvKeyDown()
		void EvSize(UINT SizeType, TSize& size);
		void Paint(TDC& dc, BOOL, TRect&);

	private:
		TPoint				WSize;
		TPoint 				mouseXY;
		TBitmap*				ScratchBmp;
		TBitmap*				StrchedBmp;
		TBitmap*				Background;
		TBitmap*				Mono;
		TBitmap*				Ship1;
		TBitmap* 			Ship2;
		JTextUtils*			TXTEffects;
		JTextUtils*			TXT2;
		int 					OldX[MAX_SPRITES];
		int 					OldY[MAX_SPRITES];
		int 					X[MAX_SPRITES];
		int 					Y[MAX_SPRITES];
		int 					DeltaX[MAX_SPRITES];
		int 					DeltaY[MAX_SPRITES];
		int 					Sprite_State[MAX_SPRITES];
		int 					Dest_Frame[MAX_SPRITES];
		int 					NUM_SPRITES;
		int					Bump_Flag[MAX_SPRITES];
		// This flag is used as an error checking device.
		// in the event that a sprite comes in contact with
		// a 2 objects (wall or another sprite) at same time,
		// bump flag will be one if sprite was bumped during
		// CNewXY, if it is bumped again before being drawn,
		// Bump flag will again be incremented flagging a potential
		// error, therefore it is destroyed.
		// Bump = 0 => not bumped this cycle
		// Bump = 1 => Bumped once this cycle
		// Bump > 1 => Bumped more than once this cycle -DESTROY-
		// Because of the random nature of this bug, its fix actually
		// looks planned
		//**************************************************************

		// Function Prototypes
		void CNewXY();
		void ColCheck(int);
		void InitSpriteLocations();
		void CheckFlagStatus();
		void DoDestroy(int);
		void DoCreate(int);

	DECLARE_RESPONSE_TABLE(TJScrWindow);
};    // end class TJScrWindow Declaration

DEFINE_RESPONSE_TABLE1(TJScrWindow, TFrameWindow)
	EV_WM_TIMER,
	EV_WM_LBUTTONDOWN,
// EV_WM_RBUTTONDOWN,
// EV_WM_MOUSEMOVE,
// EV_WM_KEYDOWN,
	EV_WM_SIZE,
END_RESPONSE_TABLE;

TJScrWindow::TJScrWindow(TWindow*parent, const char far * title) :
		TFrameWindow(parent,title)
{
 MyLogPalette = (LOGPALETTE*)new char[sizeof(LOGPALETTE)+sizeof(PALETTEENTRY)*17];
 MyLogPalette->palVersion = 0x300;
 MyLogPalette->palNumEntries = 17;
 for (int i=0;i<17;++i)
 {
	MyLogPalette->palPalEntry[i].peRed = Colors[i].Red();
	MyLogPalette->palPalEntry[i].peGreen = Colors[i].Green();
	MyLogPalette->palPalEntry[i].peBlue = Colors[i].Blue();
	MyLogPalette->palPalEntry[i].peFlags = PC_RESERVED;
 }

 TScreenDC screenDC;
 PalDevice = (screenDC.GetDeviceCaps(RASTERCAPS) & RC_PALETTE) ? TRUE : FALSE;

 GetCursorPos(mouseXY);
 ShowCursor(FALSE);
 Attr.Style = WS_POPUP;
 Attr.X = 0 ;
 Attr.Y = 0;
 Attr.W = GetSystemMetrics(SM_CXFULLSCREEN);
 Attr.H = GetSystemMetrics(SM_CYFULLSCREEN)+GetSystemMetrics(SM_CYCAPTION);
 Background = new TBitmap(*GetApplication(), 1);
 Ship1 = new TBitmap(*GetApplication(), 2);
 Ship2 = new TBitmap(*GetApplication(), 4);
 Mono = new TBitmap(*GetApplication(), 3);
 TXTEffects = new JTextUtils(550,320);
 TXT2			= new JTextUtils(0,550);
 TXT2->Set_ColorDir(5);
 TXT2->Set_JFont(13,8,"Stop");
 ScratchBmp = 0;
 StrchedBmp = 0;
 Intro_Timer = 0;
 randomize();
 NUM_SPRITES = random(8)+2;
 InitSpriteLocations();
}

TJScrWindow::~TJScrWindow()
{
	delete Background;
	delete Ship1;
	delete Ship2;
	delete Mono;
	delete ScratchBmp;
	delete StrchedBmp;
	delete TXTEffects;
	delete TXT2;
}

void TJScrWindow::SetupWindow()
{
	TFrameWindow::SetupWindow();
	TClientDC jcDC(*this);
	ScratchBmp = new TBitmap(jcDC, 75, 75);
	StrchedBmp = new TBitmap(jcDC, 850, 650);
	Timer = SetTimer(1,10,0);
	if (Timer == 0)
		MessageBox("NO TIMERS T1", "Error", MB_OK);
}


void TJScrWindow::EvSize(UINT sizeType, TSize&size)
{
	TFrameWindow::EvSize(sizeType, size);
	WSize.x = size.cx;
	WSize.y = size.cy;

	TClientDC jcDC(*this);
	TMemoryDC stretchedDC(jcDC);
	TMemoryDC memDC(jcDC);
	stretchedDC.SelectObject(*StrchedBmp);
	memDC.SelectObject(*Background);
	HCURSOR oldCur = ::SetCursor(::LoadCursor(0, IDC_WAIT));
	stretchedDC.StretchBlt(0,0,WSize.x, WSize.y, memDC, 0, 0, 640,480, SRCCOPY);
	::SetCursor(oldCur);
	Invalidate();
}



void TJScrWindow::Paint(TDC& dc, BOOL, TRect&)
{
	int i;
	TMemoryDC memDC(dc);
	memDC.SelectObject(*StrchedBmp);
	dc.BitBlt(0, 0, WSize.x, WSize.y, memDC, 0, 0, SRCCOPY);
	for(i=0; i<NUM_SPRITES; i++)
	{
		memDC.SelectObject(*Mono);
		dc.BitBlt(OldX[i],OldY[i],SPRITE_SIZE,SPRITE_SIZE,memDC,0,0,SRCAND);
		if ((i % 2 ) == 0)
		{
			memDC.SelectObject(*Ship1);
			dc.BitBlt(OldX[i],OldY[i],SPRITE_SIZE,SPRITE_SIZE,memDC,0,0,SRCPAINT);
		}
		else
		{
			memDC.SelectObject(*Ship2);
			dc.BitBlt(OldX[i],OldY[i],SPRITE_SIZE,SPRITE_SIZE,memDC,0,0,SRCPAINT);
		}
	}
}

void TJScrWindow::EvTimer(UINT)
{
	if (++Intro_Timer >= INTRODUCE_TIME)
	{
		DoCreate(NUM_SPRITES);
		Intro_Timer = 0;
	}
 //	TClientDC winDC(*this);
	TClientDC *winDC;
	PALETTEENTRY PaletteEntry = MyLogPalette->palPalEntry[0];
	for (int k=0;k<17-1;k++)
		MyLogPalette->palPalEntry[k] = MyLogPalette->palPalEntry[k+1];
	MyLogPalette->palPalEntry[k] = PaletteEntry;

	winDC = new TClientDC(HWindow);
	TPalette Palette(MyLogPalette);
	winDC->SelectObject(Palette);
	winDC->RealizePalette();
	TMemoryDC bits(*winDC);
	TMemoryDC back(*winDC);
	TXTEffects->Set_JDC(winDC);
	TXT2->Set_JDC(winDC);
	int bx,by;
	int i;
	CNewXY();
	for (i=0;i<NUM_SPRITES;i++)
	{
		if (Sprite_State[i])
		{
		 if (Sprite_State[i]==2)
		 {
			// Dying
			// Do Animation Update
			if(Dest_Frame[i] < 6)
			{
				bx = min(X[i],OldX[i]);
				by = min(Y[i],OldY[i]);
				int bw = SPRITE_SIZE + abs(OldX[i] - X[i]);
				int bh = SPRITE_SIZE + abs(OldY[i] - Y[i]);
				back.SelectObject(*ScratchBmp);
				bits.SelectObject(*StrchedBmp);
				back.BitBlt(0,0,bw,bh,bits,bx,by,SRCCOPY);
				if (Dest_Frame[i] < 5)
				{
					bits.SelectObject(*Mono);
					back.StretchBlt(0,0,SPRITE_SIZE-Dest_Frame[i]*10,
							SPRITE_SIZE-Dest_Frame[i]*10,bits,0,0,60,60,SRCAND);
					if ((i % 2) ==0)
					{
					bits.SelectObject(*Ship1);
					back.StretchBlt(0,0,SPRITE_SIZE-10*Dest_Frame[i],
							SPRITE_SIZE-10*Dest_Frame[i],bits,0,0,60,60,SRCPAINT);
					}
					else
					{
					bits.SelectObject(*Ship2);
					back.StretchBlt(0,0,SPRITE_SIZE-10*Dest_Frame[i]
							,SPRITE_SIZE-10*Dest_Frame[i],bits,0,0,60,60,SRCPAINT);
					}
				}
				winDC->BitBlt(bx,by,bw,bh,back,0,0,SRCCOPY);
				Dest_Frame[i]++;
			} // end if destframe<3
			else
			{
			 Sprite_State[i] = DESTROYED;
			}
		 }
		 else
		 {
			// Destroyed
			// Attempt Re-init Sprite
			if (random(100) > 95) // 5% chance per iteration
				DoCreate(i);
		 }
		}
		else
		{
			bx = min(X[i],OldX[i]);
			by = min(Y[i],OldY[i]);
			int ox = abs(X[i]-bx);
			int oy = abs(Y[i]-by);
			int bw = SPRITE_SIZE + abs(OldX[i] - X[i]);
			int bh = SPRITE_SIZE + abs(OldY[i] - Y[i]);
			back.SelectObject(*ScratchBmp);
			bits.SelectObject(*StrchedBmp);
			back.BitBlt(0,0,bw,bh,bits,bx,by,SRCCOPY);
			bits.SelectObject(*Mono);
			back.BitBlt(ox,oy,SPRITE_SIZE,SPRITE_SIZE,bits,0,0,SRCAND);
			if ((i % 2) ==0)
			{
				bits.SelectObject(*Ship1);
				back.BitBlt(ox,oy,SPRITE_SIZE,SPRITE_SIZE,bits,0,0,SRCPAINT);
			}
			else
			{
				bits.SelectObject(*Ship2);
				back.BitBlt(ox,oy,SPRITE_SIZE,SPRITE_SIZE,bits,0,0,SRCPAINT);
			}

			winDC->BitBlt(bx,by,bw,bh,back,0,0,SRCCOPY);

			OldX[i] = X[i];
			OldY[i] = Y[i];
		} // End If not Destroyed -else clause-


	} // end for i
	if (TXTEffects->AI_Interface())
	{
		back.SelectObject(*StrchedBmp);
		winDC->BitBlt(538,294,192,212,back,538,294,SRCCOPY);
	}
	TXT2->Pulsate(1,0,0,0);
	TXT2->Scroll();
	winDC->RestorePalette();
	delete winDC;
}

void TJScrWindow::CNewXY()
{

	int i;

	for(i=0;i<NUM_SPRITES;i++)
	{
		if(Sprite_State[i]==ACTIVE)
		{
		ColCheck(i);
		CheckFlagStatus();
		X[i] += DeltaX[i];
		Y[i] += DeltaY[i];
		}
	} // end for i
}

void TJScrWindow::ColCheck(int index)
{
 // returns true if collision detected
 int i,xhold,yhold,temp;

 // This Checks for collisions with other sprites..
 for (i=index+1; i< NUM_SPRITES; i++)
 {
	if(((X[index]+DeltaX[index]+SPRITE_SIZE > X[i]+DeltaX[i])&&
		(X[index]+DeltaX[index] < X[i]+SPRITE_SIZE+DeltaX[i]))&&
	  ((Y[index]+SPRITE_SIZE+DeltaY[index] > Y[i]+DeltaY[i])&&
		(Y[index]+DeltaY[index] < Y[i]+DeltaY[i]+SPRITE_SIZE)))
	{
		xhold = min(abs((X[index]+SPRITE_SIZE+DeltaX[index])-(X[i]+DeltaX[i])),
						abs((X[index]+DeltaX[index])-(X[i]+DeltaX[i]+SPRITE_SIZE)));
		yhold = min(abs((Y[index]+SPRITE_SIZE+DeltaY[index])-(Y[i]+DeltaY[i])),
						abs((Y[index]+DeltaY[index])-(Y[i]+SPRITE_SIZE+DeltaY[i])));
		temp = abs(xhold-yhold);

		// Special Case Collision Near corner -swap all speeds-
		if (temp <= 3)
			{
			 temp = DeltaY[index];
			 DeltaY[index] = DeltaY[i];
			 DeltaY[i] = temp;
			 temp = DeltaX[index];
			 DeltaX[index] = DeltaX[i];
			 DeltaX[i] = temp;
			}
		else // normal case collision on side -swap speeds wrt side-
		{
			if (xhold > yhold)
			{
				temp = DeltaY[index];
				DeltaY[index] = DeltaY[i];
				DeltaY[i]=temp;
			}
			else
			{
				temp = DeltaX[index];
				DeltaX[index] = DeltaX[i];
				DeltaX[i] = temp;
			}
		} // end normal case
		Bump_Flag[i]++;
		Bump_Flag[index]++;
	} // end if collision occured
 }  //end for i

 // This Checks for colissions with the wall
 if (X[index]+DeltaX[index]> WSize.x-SPRITE_SIZE || X[index]+DeltaX[index]<0)
 {
	DeltaX[index] = -DeltaX[index];
	Bump_Flag[index]++;
 }
 if(Y[index]+DeltaY[index]>WSize.y-SPRITE_SIZE-20||Y[index]+DeltaY[index]<0)
 {
	DeltaY[index] = -DeltaY[index];
	Bump_Flag[index]++;
 }

// Do The AI Screen Collision Check
 if(((X[index]+DeltaX[index]+SPRITE_SIZE > B_Left)&&
	  (X[index]+DeltaX[index] < B_Right))&&
	 ((Y[index]+DeltaY[index]+SPRITE_SIZE > B_Top )&&
	  (Y[index]+DeltaY[index] < B_Bottom)))
 {
	xhold = min(abs((X[index]+SPRITE_SIZE+DeltaX[index])-(B_Left)),
					abs((X[index]+DeltaX[index]) - (B_Right)));
	yhold = min(abs((Y[index]+SPRITE_SIZE+DeltaY[index])-(B_Top)),
					abs((Y[index]+DeltaY[index])-(B_Bottom)));
	if(xhold>yhold)
	{
		DeltaY[index] = -DeltaY[index];
		Bump_Flag[index]++;
	}
	else
	{
		DeltaX[index]= -DeltaX[index];
		Bump_Flag[index]++;
	}
 } // end of AI screen Collision Check

} // end colCheck

void TJScrWindow::InitSpriteLocations()
{
	int i,j;
	for (i=0; i <(int)((NUM_SPRITES/3)+1); i++)
	{
	 for(j=0;j<3;j++)
	 {
		if (i*3+j == NUM_SPRITES)
			return;
		OldY[i*3+j]=j*(200);
		 Y[i*3+j] = OldY[j];
		OldX[i*3+j]=i*(200);
		X[i*3+j] = OldX[i*3+j];
		DeltaX[i*3+j] = random(16)-8;
		DeltaY[i*3+j] = random(20)-8;
		Bump_Flag[i*3+j] = 0;
		Sprite_State[i*3+j]=ACTIVE;
	 }
	}
} // end of initspritelocations

void TJScrWindow::CheckFlagStatus()
{
	for (int i=0;i<NUM_SPRITES;i++)
	{
	if (Bump_Flag[i] > 1)
		DoDestroy(i);
	// Reinit Flags for next screen update
	Bump_Flag[i] = 0;
	}
}

void TJScrWindow::DoDestroy(int index)
{
 Sprite_State[index] = DYING;
 Dest_Frame[index]=1;
}

void TJScrWindow::DoCreate(int index)
{
 if (index < MAX_SPRITES)
 {
	if(index >= NUM_SPRITES)
	{
		DeltaX[index] = random(20)-8;
		DeltaY[index] = random(16)-6;
		NUM_SPRITES++;
	}
	Sprite_State[index] = ACTIVE;
	OldX[index] = 0;
	OldY[index] = 0;
	X[index] = 0;
	Y[index] = 0;
 }
}



void TJScrWindow::EvLButtonDown(UINT, TPoint&)
{
 KillTimer(Timer);
 ShowCursor(TRUE);
 TWindow::CmExit();
}


// ****************************************************************
// ****************************END OF CLASS JSCRWINDOW*************


//********************************************************************
class TJApp : public TApplication
{
	public:
		TJApp() : TApplication(){}
		void InitMainWindow(){MainWindow = new TJScrWindow(0,"GRAPHX Test");}
};

int OwlMain(int,char* [])
{
	TJApp app;
	return app.Run();
}
