/* *****************************************************
Graphics Project #1
Jeremy C. Witt
462.35.8529
2/6/96

This Program demonstrates the ability to create and manipulate
objects using Vector Representations.
Each Object is stored as a vector and then Displayed in a
random location, with a random decay time, and a Random color.
The Objects included are Triangle, Square, and Pentagon.

*/
#include <stdlib.h>
#include <stdio.h>
#include <graphics.h>
#include <math.h>
#include <dos.h>
#include <time.h>
#include <conio.h>

unsigned char far *video_buffer = (char far *)0xA0000000L;
void Plot_Pixel_Fast(int x, int y, unsigned char color);

// Structure for Objects
typedef struct
{
	float X;
	float Y;
	float dX;
	float dY;
} Object;


void Init_System(void);
void Setup_Screen(void);
void Init_Objects(Object* shape,int ,int );
void Do_Animate(void);

void main()
{
	long index;
	// These are the Shapes Triangle,Square,Pentagon
	Init_System();
	Setup_Screen();
	randomize();
	Do_Animate();


	for( index=0; index<=100000; index++,Plot_Pixel_Fast(rand()%640,
		rand()%480,0));
	closegraph();
}                      // End of Main

void Init_System()
{
	int g_driver, g_mode, g_error;
	detectgraph(&g_driver,&g_mode); //Detect Graphics Mode
	initgraph(&g_driver,&g_mode,"");
	g_error=graphresult();
	if (g_error)
	{
		printf("Error Initializing Graphics Mode: %s.\n",
			grapherrormsg(g_error));
		exit(1);
	}
} // End of Init_System

void Setup_Screen()
{
	char *Msg1 = "Project 1";
	char *Msg2 = "FEB 6,1996";
	char *Msg3 = "CS-4395";
	char *Msg4 = "Texas Tech";
	char *Msg5 = "University";
	char *Msg6 = "Jeremy Witt";
	char *Msg7 = "462.35.8529";

	// Set current view and nameplate line/text color
	setviewport(0,0,640,480,1);
	setcolor(15);

	// set line for border
	setlinestyle(SOLID_LINE,1,3); // Thick Line

	// at location 0,0
	// Draw Box box around screen
	lineto(0,479);  // 479..Just inside screen
	lineto(639,479);
	lineto(639,0);
	lineto(0,0);


	// Draw Nameplate Separators
	moveto(99,0);
	lineto(99,479);
	moveto(0,159);
	lineto(99,159);
	moveto(0,319);
	lineto(99,319);

	// Output Messages
	outtextxy(4,49,Msg1);
	outtextxy(4,99,Msg2);
	outtextxy(4,349,Msg3);
	outtextxy(4,399,Msg4);
	outtextxy(4,419,Msg5);
	outtextxy(4,209,Msg6);
	outtextxy(4,249,Msg7);

	// Set Line to 1 pixel Width for drawing
	setlinestyle(SOLID_LINE,1,1);
}  // End of Setup_Screen

void Init_Objects(Object* shape,int NumPoints, int Lambda)
{
	switch (NumPoints)
	{
		case 3:
		{
			shape[0].X = random(350)+100;
			shape[0].Y = random(300)+50;
			shape[0].dX = .5; //cos 60
			shape[0].dY = -.8660254; //sin(-60)
			shape[1].X = shape[0].X+.5*Lambda;
			shape[1].Y = shape[0].Y-.8660254*Lambda;
			shape[1].dX = .5;
			shape[1].dY = .8660254;
			shape[2].X = shape[0].X+Lambda;
			shape[2].Y = shape[0].Y;
			shape[2].dX = -1;
			shape[2].dY = 0;
		};
		break;

		case 4:
		{
			shape[0].X = random(350)+100;
			shape[0].Y = random(350);
			shape[0].dX = 1; //cos 90
			shape[0].dY = 0; //sin(-90)
			shape[1].X = shape[0].X+Lambda;
			shape[1].Y = shape[0].Y;
			shape[1].dX = 0;
			shape[1].dY = 1;
			shape[2].X = shape[0].X+Lambda;
			shape[2].Y = shape[0].Y+Lambda;
			shape[2].dX = -1;
			shape[2].dY = 0;
			shape[3].X = shape[0].X;
			shape[3].Y = shape[0].Y+Lambda;
			shape[3].dX = 0;
			shape[3].dY = -1;
		};
		break;

		case 5:
		{
			shape[0].X = random(350)+100;
			shape[0].Y = random(300)+50;
			shape[0].dX = .80902; //cos 72
			shape[0].dY = -.58778; //sin(-72)
			shape[1].X = shape[0].X+.80902*Lambda;
			shape[1].Y = shape[0].Y-.58778*Lambda;
			shape[1].dX = .80902;
			shape[1].dY = .58778;
			shape[2].X = shape[1].X+.80902*Lambda;
			shape[2].Y = shape[0].Y;
			shape[2].dX = -.30902;
			shape[2].dY =  .95106;
			shape[3].X = shape[2].X-.30902*Lambda;
			shape[3].Y = shape[2].Y+.95102*Lambda;
			shape[3].dX = -1;
			shape[3].dY = 0;
			shape[4].X = shape[0].X+.30902*Lambda;
			shape[4].Y = shape[3].Y;
			shape[4].dX=-.30902;
			shape[4].dY=-.95102;

		};
		break;
	} // End Switch
}   // End of Init_Objects

void Do_Animate(void)
{
	Object Shape[5];

	int 	color;
	int 	Current_Shape;
	float Decay; // speed of decay
	int 	Lambda; //
	float	Line_Length; // Used in scaling the Direction Vectors dX, and dY
	int 	i,j,term;   // counters
	int 	Exit=0;

	// Start Animate Loop
	for(i=0;i<1000;i++)
	{
		color = random(15)+1;
		setcolor(color);
		Current_Shape = random(3)+3;
		Lambda = random(100)+50;

		// You can also calculate the Change using .8 instead of .2
		Decay = (random(16)+15);
		Decay = Decay/100.0; // A Number between .15 and .30
		Init_Objects(Shape,Current_Shape,Lambda);
		do
		{
			// Move to the First Point of Object
			moveto(Shape[0].X,Shape[0].Y);

			// Draw the Object
			for (j=0;j<Current_Shape;j++)
			{
			 // This Goes to Zero if Shape needs to be terminated
			 term = j;
			 if (term == Current_Shape)
				term = 0;
			 lineto((Shape[term].X+Lambda*Shape[term].dX),
					  (Shape[term].Y+Lambda*Shape[term].dY));

			} //  end for j

			// Calculate New Location Using Modified version of Formula
			for (j=0;j<Current_Shape;j++)
			{
			 // Calculate and Store new Points
				Shape[j].X = Shape[j].X+(Decay*Lambda*Shape[j].dX);
				Shape[j].Y = Shape[j].Y+(Decay*Lambda*Shape[j].dY);
			}

			for (j=0;j<Current_Shape;j++)
			{
			  // Calculate and Store New Direction Vectors For Shape
			  // Also Uses Given Formula
				term = j+1;
				if (term == Current_Shape)
					term =0;
				Shape[j].dX = Shape[term].X-Shape[j].X;
				Shape[j].dY = Shape[term].Y-Shape[j].Y;

				// Apply the distance formula so we can scale direction vector
				Line_Length = sqrt(pow(Shape[j].dX,2)+pow(Shape[j].dY,2));
				Shape[j].dX = Shape[j].dX/Line_Length;
				Shape[j].dY = Shape[j].dY/Line_Length;
				Lambda = Line_Length;
			}
			if (Lambda < 8) // Then Exit Because Shape has been reduced
				Exit = 1;
			if (kbhit())
			{
				long index;
				for( index=0; index<=100000; index++,Plot_Pixel_Fast(rand()%640,
				rand()%480,0));
				closegraph();
				exit(1);
			}

			delay(50);
		}
		while(!Exit);
      Exit = 0;

	} // end For i
}


// Just a Little Flourish
void Plot_Pixel_Fast(int x, int y, unsigned char color)
{
	video_buffer[((y<<8) + (y<<6)) + x] = color;
}
