/***********************************************
Project 5
Jeremy C. Witt
462.35.8529
z3a12@ttacs3.ttu.edu
http://pegasus.acs.ttu.edu/~z3a12
This is an Part 2 of the Transformation Pipeline
with Non-Linear Decoration (sort of) The Texas
Map is placed on the XY Plane (Ground) and Cubes
are placed in the Sky (Above XY Plane). The Shadows
of the Cubes are then calculated as they are
projected from a light source to the XY Plane
(From here on out referred to as the GPlane)
***********************************************/

#include <stdio.h>
#include <math.h>
#include <graphics.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>

// Colors Used
#define ltgray 7
#define dkgray 8
#define brown 6
#define yellow 14
#define ltred 12
#define blue 1
#define white 15
#define red 4
#define construct 12
#define green 2
#define black 0

// Definition of Various Components of Vectors and Such
#define X_COMP 0
#define Y_COMP 1
#define Z_COMP 2
#define N_COMP 3

// The 3 Dimensional Vector Type
typedef struct vector_type
{
 float p[4]; // a 3d point with normalizing vector
} vector, *vector_ptr;

// The 4X4 Matrix Type for Transformations in 3D
typedef struct matrix_type
{
 float elem[4][4];
} matrix, *matrix_ptr;


// The Object Type used to hold 3D Verticies of objects
// found in scene
typedef struct object_type
{
 vector Point[440];
} object, *object_ptr;

// A Smaller Object for the Double T
typedef struct ttob_type
{
 vector Point[25];
} ttob, *ttob_ptr;


// An Even Smaller Object for the Shadows
typedef struct shadow_type
{
 vector Point[5];
} shadow, *shadow_ptr;


// The Object Type that holds seed points for cube
// and Texas Map. Same as object_type except uses
// less memory...
typedef struct seedob_type
{
 vector Point[3];
} seedob, *seedob_ptr;

// 6 Vectors for the 6 Point 3D Coordinate Axis
// Note: This was mainly a testing feature, this program
// incorporates only X and Y Axis Indicators (Green) to
// denote the GPlane
typedef struct axes_type
{
 vector Point[6];
} axesob, *axesob_ptr;

// Map_Type is a special type that holds the Texas Map
// and allows for easy transfer to procedures
typedef struct map_type
{
 int Vertex[440][2];
} maptype, *maptype_ptr;

// Same as Maptype, but uses less memory for TTLogo
typedef struct tt_type
{
 int Vertex[26][2];
} tttype, *tttype_ptr;

// Used By SCaling Routines
int xsize,ysize;
int bound;

// Prototypes
void Mat_Mul(vector_ptr,matrix_ptr);
float CR_Sigma(vector_ptr , matrix_ptr);
void initialize(void);
void Define_Cube(object_ptr);
void Translate_Cube(object_ptr,int,int,int,int);
void Draw_Object(object_ptr,int);
void Fill_Object(object_ptr,int);
void World_Viewer(object_ptr,matrix_ptr,int);
void Viewer_Project(object_ptr,int,int);
void TwoD_ThreeD(object_ptr,int,maptype_ptr,float,int,int,int);
void Draw_Axes(matrix_ptr);
void Rotate_Object_WCS(object_ptr,int,int,int);
void Project_Shadow(object_ptr,vector_ptr,matrix_ptr,int);

// ***********************MAIN ROUTINE******************
main()
{
   int mx,my;	// Used for scaling texas Map
   float d;		// distance from camera to View Plane
   float rho;  // Distance from camera to Origin in WCS
   float x,y;  // File INput Vars
   int junk;   // JUNK... Duh...
   int index,numpts; // counter variable, and Map Number of Points Respective
   vector Evect;    // This vector defines virtual Camera in WCS
   vector Light;   // This is the Light Source
	matrix TSigma; // This is the Aggregiate Matrix for Transformation Pipeline
   seedob CubeSeeds; //0 Left, 1 Top 2 Right Seeds for various sides (Blue)
   seedob CubeSeed2; // Seeds for Cube 2 (Red)
   seedob CubeSeed3; // Seeds for Cube 3 (White)
   vector TexasSeed; // This is just the Center (Approx) of the Texas Map
	object Cube;  // a standard Cube (0,0,0) to (100,100,100) (Blue)
   object Cube2; // "" "" (RED)
   object Cube3; // "" "" (WHITE)
   object Map;  // This will hold the 3d version of the 2d Texas Map
   ttob Dout; // This will hold the 3d version of the 2s Double T
   tttype dout; // This holds the 2d Double T
	maptype map; // This holds the 2d Texas Map

   FILE *mapfile; // This file contains all vertices for Texas Map
//end of var declaration

   // Setup Graphics
   initialize();

	// Set Virtual Camera to (200,200,282.8) which is:
   // Theta=pi/4
   // Phi  =pi/4
   // Rho  =400
   Evect.p[X_COMP]=200.0;
   Evect.p[Y_COMP]=200.0;
   Evect.p[Z_COMP]=282.8;
   Evect.p[N_COMP]=1.0;

/*   Evect.p[X_COMP]=400.0;
   Evect.p[Y_COMP]=50.0;
   Evect.p[Z_COMP]=100.8;
   Evect.p[N_COMP]=1.0; */


   // This is the Light Source.. Notice that it is defined at a large dist
   // from the Scene This is to Keep Shadows Small.
   Light.p[X_COMP]=600.0;
   Light.p[Y_COMP]=-400.0;
   Light.p[Z_COMP]=800.0;
   Light.p[N_COMP]=1.0;

   // Set up the Seed point for Texas Map on GPlane
   TexasSeed.p[X_COMP]=0.0;
   TexasSeed.p[Y_COMP]=0.0;
   TexasSeed.p[Z_COMP]=0.0;
   TexasSeed.p[N_COMP]=1.0;

   // Set seed points of cube to middle of each face in WCS
   // Cube 1 (BLUE)
   CubeSeeds.Point[0].p[X_COMP] = 25.0;
   CubeSeeds.Point[0].p[Y_COMP] = 12.5;
   CubeSeeds.Point[0].p[Z_COMP] = 12.5;
   CubeSeeds.Point[0].p[N_COMP] = 1.0;
   CubeSeeds.Point[1].p[X_COMP] = 12.5;
   CubeSeeds.Point[1].p[Y_COMP] = 12.5;
   CubeSeeds.Point[1].p[Z_COMP] = 25.0;
   CubeSeeds.Point[1].p[N_COMP] = 1.0;
   CubeSeeds.Point[2].p[X_COMP] = 12.5;
   CubeSeeds.Point[2].p[Y_COMP] = 25.0;
   CubeSeeds.Point[2].p[Z_COMP] = 12.5;
   CubeSeeds.Point[2].p[N_COMP] = 1.0;

   // Cube2 (Red)
   CubeSeed2.Point[0].p[X_COMP] = 25.0;
   CubeSeed2.Point[0].p[Y_COMP] = 12.5;
   CubeSeed2.Point[0].p[Z_COMP] = 12.5;
   CubeSeed2.Point[0].p[N_COMP] = 1.0;
   CubeSeed2.Point[1].p[X_COMP] = 12.5;
   CubeSeed2.Point[1].p[Y_COMP] = 12.5;
   CubeSeed2.Point[1].p[Z_COMP] = 25.0;
   CubeSeed2.Point[1].p[N_COMP] = 1.0;
   CubeSeed2.Point[2].p[X_COMP] = 12.5;
   CubeSeed2.Point[2].p[Y_COMP] = 25.0;
   CubeSeed2.Point[2].p[Z_COMP] = 12.5;
   CubeSeed2.Point[2].p[N_COMP] = 1.0;

   // Cube3 (WHITE)
   CubeSeed3.Point[0].p[X_COMP] = 25.0;
   CubeSeed3.Point[0].p[Y_COMP] = 12.5;
   CubeSeed3.Point[0].p[Z_COMP] = 12.5;
   CubeSeed3.Point[0].p[N_COMP] = 1.0;
   CubeSeed3.Point[1].p[X_COMP] = 12.5;
   CubeSeed3.Point[1].p[Y_COMP] = 12.5;
   CubeSeed3.Point[1].p[Z_COMP] = 25.0;
   CubeSeed3.Point[1].p[N_COMP] = 1.0;
   CubeSeed3.Point[2].p[X_COMP] = 12.5;
   CubeSeed3.Point[2].p[Y_COMP] = 25.0;
   CubeSeed3.Point[2].p[Z_COMP] = 12.5;
   CubeSeed3.Point[2].p[N_COMP] = 1.0;

   // Set Double T Structure with general T values
  	dout.Vertex[0][0] =0;
	dout.Vertex[0][1] =0;
	dout.Vertex[1][0] =18;
	dout.Vertex[1][1] =0;
	dout.Vertex[2][0] =18;
	dout.Vertex[2][1] =5;
	dout.Vertex[3][0] =14;
	dout.Vertex[3][1] =5;
	dout.Vertex[4][0] =14;
	dout.Vertex[4][1] =4;
	dout.Vertex[5][0] =11;
	dout.Vertex[5][1] =4;
	dout.Vertex[6][0] =11;
	dout.Vertex[6][1] =7;
	dout.Vertex[7][0] =15;
	dout.Vertex[7][1] =7;
	dout.Vertex[8][0] =15;
	dout.Vertex[8][1] =10;
	dout.Vertex[9][0] =11;
	dout.Vertex[9][1] =10;
	dout.Vertex[10][0]=11;
	dout.Vertex[10][1]=17;
	dout.Vertex[11][0]=13;
	dout.Vertex[11][1]=17;
	dout.Vertex[12][0]=13;
	dout.Vertex[12][1]=20;
	dout.Vertex[13][0]=5;
	dout.Vertex[13][1]=20;
	dout.Vertex[14][0]=5;
	dout.Vertex[14][1]=17;
	dout.Vertex[15][0]=7;
	dout.Vertex[15][1]=17;
	dout.Vertex[16][0]=7;
	dout.Vertex[16][1]=10;
	dout.Vertex[17][0]=3;
	dout.Vertex[17][1]=10;
	dout.Vertex[18][0]=3;
	dout.Vertex[18][1]=7;
	dout.Vertex[19][0]=7;
	dout.Vertex[19][1]=7;
	dout.Vertex[20][0]=7;
	dout.Vertex[20][1]=4;
	dout.Vertex[21][0]=4;
	dout.Vertex[21][1]=4;
	dout.Vertex[22][0]=4;
	dout.Vertex[22][1]=5;
	dout.Vertex[23][0]=0;
	dout.Vertex[23][1]=5;
	dout.Vertex[24][0]=dout.Vertex[0][0];
	dout.Vertex[24][1]=dout.Vertex[0][1];
   index=0;
   mx=0;
   my=0;

   // scale Double T for use on sides of Cubes (invert Y)
   for (index = 0;index<=24;index++)
   {
    dout.Vertex[index][0] = (dout.Vertex[index][0])+4;
    dout.Vertex[index][1] = (20-dout.Vertex[index][1])+2;
   }

   index=0;
   // Open and Read Texas.Map into map which is the 2d map struct
   mapfile = fopen("texas.map","r");
	while(fscanf(mapfile,"%f %f %d",&x,&y,&junk) !=EOF)
	{
		map.Vertex[index][0] = x;
		map.Vertex[index][1] = y;
		if (x > mx) mx = x;
		if (y > my) my = y;
		index++;
	}
	numpts = index;

   map.Vertex[numpts][0] = map.Vertex[0][0];
	map.Vertex[numpts][1] = map.Vertex[0][1];

   // Scale Texas map for use as 3d Object
   bound = xsize/4.5;
	for(index=0;index<=numpts;index++)
	{
		map.Vertex[index][0] = ((float)map.Vertex[index][0]/mx*(xsize-bound))*0.2;
		map.Vertex[index][1] = ysize-(map.Vertex[index][1]/(float)my*ysize)*0.2;
		map.Vertex[index][0] = map.Vertex[index][0] + (xsize - bound)*0.1;
		map.Vertex[index][1] = map.Vertex[index][1] - ysize*0.15;
		map.Vertex[index][0] = map.Vertex[index][0] - 50.0;
		map.Vertex[index][1] = 480-(map.Vertex[index][1]+76) ;
	}

   // Make the Texas Big...
   // Note: This Step could be combined with the above steps to save
   // processing time.
   for (index=0;index<=numpts;index++)
   {
   	map.Vertex[index][0] = (3*(map.Vertex[index][0]))-100.0;
      map.Vertex[index][1] = (3*(map.Vertex[index][1]))-50.0;
   }

   // Create The Sigma Matrix using The Camera Vector
   // Note: Rho, although Returned is not used
  	rho = CR_Sigma((vector_ptr)&Evect,(matrix_ptr)&TSigma);

   // Set the view plane distance
  	d = 450;

   // This Will draw the GPLANE
   Draw_Axes((matrix_ptr)&TSigma);

   setcolor(white);
   // Create 3d object out of 2d map for Texas face 0
   TwoD_ThreeD((object_ptr)&Map,numpts,(maptype_ptr)&map,0.0,Z_COMP,98,96);

   // Transform 3d Texas Map in WCS to Screen Coords
   World_Viewer((object_ptr)&Map,(matrix_ptr)&TSigma,numpts);
  	Viewer_Project((object_ptr)&Map,numpts,d);

   // Draw Texas Map
   Draw_Object((object_ptr)&Map,numpts);

   // Fill The Texas Map By Transforming Seed and Filling
   // using Floodfill
   Mat_Mul((vector_ptr)&TexasSeed,(matrix_ptr)&TSigma);
   Viewer_Project((object_ptr)&TexasSeed,0,d);
   setfillstyle(1,brown);
   floodfill(TexasSeed.p[X_COMP],TexasSeed.p[Y_COMP],white);
   // Now make the Texas Outline Black
   setcolor(black);
   Draw_Object((object_ptr)&Map,numpts);


   setcolor(construct);

   // Setup the 3D Cube in WCS (BLUE)
   Define_Cube((object_ptr)&Cube);
   Rotate_Object_WCS((object_ptr)&Cube,14,Z_COMP,20);
   Rotate_Object_WCS((object_ptr)&CubeSeeds,2,Z_COMP,20);
   Translate_Cube((object_ptr)&Cube,25,-25,0,14);
   Translate_Cube((object_ptr)&CubeSeeds,25,-25,0,2);

   // Cube 2 (RED)
   Define_Cube((object_ptr)&Cube2);
   Translate_Cube((object_ptr)&Cube2,100,100,25,14);
   Translate_Cube((object_ptr)&CubeSeed2,100,100,25,2);

   // Cube 3  (WHITE)
   Define_Cube((object_ptr)&Cube3);
   Translate_Cube((object_ptr)&Cube3,-55,50,30,14);
   Translate_Cube((object_ptr)&CubeSeed3,-55,50,30,2);


   // Project The Shadows of the Cubes Before Drawing the Cubes
   // (In case the cube will overlap Shadow)
   setcolor(dkgray);
   Project_Shadow((object_ptr)&Cube,(vector_ptr)&Light,(matrix_ptr)&TSigma,d);
   Project_Shadow((object_ptr)&Cube2,(vector_ptr)&Light,(matrix_ptr)&TSigma,d);
   Project_Shadow((object_ptr)&Cube3,(vector_ptr)&Light,(matrix_ptr)&TSigma,d);
   setcolor(construct);

   // Perform Transformation Pipeline on Cube 1
   // World-Coordinates to Viewer-Coordinates
   World_Viewer((object_ptr)&Cube,(matrix_ptr)&TSigma,14);
	// Viewer-Coordiantes to Screen Coordinates (Perspective Projection)
  	Viewer_Project((object_ptr)&Cube,14,d);
   Draw_Object((object_ptr)&Cube,14);

   // Fill Faces 0,left; 1,Top; 2,Front
   World_Viewer((object_ptr)&CubeSeeds,(matrix_ptr)&TSigma,2);
	Viewer_Project((object_ptr)&CubeSeeds,2,d);
   setfillstyle(1,blue);
   floodfill(CubeSeeds.Point[0].p[X_COMP],CubeSeeds.Point[0].p[Y_COMP],
    construct);
   floodfill(CubeSeeds.Point[1].p[X_COMP],CubeSeeds.Point[1].p[Y_COMP],
    construct);
   floodfill(CubeSeeds.Point[2].p[X_COMP],CubeSeeds.Point[2].p[Y_COMP],
    construct);


   // Repeat Above for Cube2 (RED)
   World_Viewer((object_ptr)&Cube2,(matrix_ptr)&TSigma,14);
	Viewer_Project((object_ptr)&Cube2,14,d);
   Draw_Object((object_ptr)&Cube2,14);
   World_Viewer((object_ptr)&CubeSeed2,(matrix_ptr)&TSigma,2);
	Viewer_Project((object_ptr)&CubeSeed2,2,d);
   setfillstyle(1,red);
   floodfill(CubeSeed2.Point[0].p[X_COMP],CubeSeed2.Point[0].p[Y_COMP],
    construct);
   floodfill(CubeSeed2.Point[1].p[X_COMP],CubeSeed2.Point[1].p[Y_COMP],
    construct);
   floodfill(CubeSeed2.Point[2].p[X_COMP],CubeSeed2.Point[2].p[Y_COMP],
    construct);


   // Repeat Above for Cube 3 (WHITE)
   World_Viewer((object_ptr)&Cube3,(matrix_ptr)&TSigma,14);
  	Viewer_Project((object_ptr)&Cube3,14,d);
   Draw_Object((object_ptr)&Cube3,14);
   World_Viewer((object_ptr)&CubeSeed3,(matrix_ptr)&TSigma,2);
	Viewer_Project((object_ptr)&CubeSeed3,2,d);
   setfillstyle(1,white);
   floodfill(CubeSeed3.Point[0].p[X_COMP],CubeSeed3.Point[0].p[Y_COMP],
    construct);
   floodfill(CubeSeed3.Point[1].p[X_COMP],CubeSeed3.Point[1].p[Y_COMP],
    construct);
   floodfill(CubeSeed3.Point[2].p[X_COMP],CubeSeed3.Point[2].p[Y_COMP],
    construct);


    setcolor(black);
   // Create 3d object out of 2d map for Double T (TT)
   // ****
   // Top of Blue Cube (TT)
   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,25.0,Z_COMP,18,26);
   Rotate_Object_WCS((object_ptr)&Dout,24,Z_COMP,20);
   Translate_Cube((object_ptr)&Dout,25,-25,0,24);
   // Transform 3d TT From WCS To Screen Coords
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
  	Viewer_Project((object_ptr)&Dout,24,d);
   setfillstyle(1,black);
   Fill_Object((object_ptr)&Dout,24);

   // Left Face of Blue Cube (TT)
   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,25.0,X_COMP,18,26);
   Rotate_Object_WCS((object_ptr)&Dout,24,Z_COMP,20);
   Translate_Cube((object_ptr)&Dout,25,-25,0,24);
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
  	Viewer_Project((object_ptr)&Dout,24,d);
   Fill_Object((object_ptr)&Dout,24);

   // Right Face of Blue Cube (TT)
   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,25.0,Y_COMP,26,8);
   Rotate_Object_WCS((object_ptr)&Dout,24,Z_COMP,20);
   Translate_Cube((object_ptr)&Dout,25,-25,0,24);
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
  	Viewer_Project((object_ptr)&Dout,24,d);
   Fill_Object((object_ptr)&Dout,24);


   // Top of Red Cube  (TT)
   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,25.0,Z_COMP,18,26);
   Translate_Cube((object_ptr)&Dout,100,100,25,24);
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
  	Viewer_Project((object_ptr)&Dout,24,d);
   setfillstyle(1,black);
   Fill_Object((object_ptr)&Dout,24);

   // Left Face of Red Cube  (TT)
   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,25.0,X_COMP,18,26);
   Translate_Cube((object_ptr)&Dout,100,100,25,24);
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
  	Viewer_Project((object_ptr)&Dout,24,d);
   Fill_Object((object_ptr)&Dout,24);

   // Right Face of Red Cube (TT)
   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,25.0,Y_COMP,26,8);
   Translate_Cube((object_ptr)&Dout,100,100,25,24);
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
  	Viewer_Project((object_ptr)&Dout,24,d);
   Fill_Object((object_ptr)&Dout,24);

   // Top of White Cube  (TT)
   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,25.0,Z_COMP,18,26);
   Translate_Cube((object_ptr)&Dout,-55,50,30,24);
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
  	Viewer_Project((object_ptr)&Dout,24,d);
   setfillstyle(1,black);
   Fill_Object((object_ptr)&Dout,24);

   // Left Face of White Cube (TT)
   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,25.0,X_COMP,18,26);
   Translate_Cube((object_ptr)&Dout,-55,50,30,24);
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
  	Viewer_Project((object_ptr)&Dout,24,d);
   Fill_Object((object_ptr)&Dout,24);

   // Right Face of White Cube  (TT)
   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,25.0,Y_COMP,26,8);
   Translate_Cube((object_ptr)&Dout,-55,50,30,24);
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
  	Viewer_Project((object_ptr)&Dout,24,d);
   Fill_Object((object_ptr)&Dout,24);


   // *******
   // Output Program Information
   setcolor(yellow);
 	outtextxy(450,30,"Project 5");
	outtextxy(450,55,"T-Pipeline iteration 2");
	outtextxy(450,80,"Jeremy C. Witt");
	outtextxy(450,105,"462.35.8529");
	outtextxy(450,130,"CS-4395 : 4/16/96");
	outtextxy(450,155,"Texas Tech University");

   // Clean Up
   getch();
   fclose(mapfile);
	closegraph();
} // end of Main

// ************************END OF MAIN**************************

// This Function Sets up the Screen Parameters (Graphics mode)
void initialize(void)
{
	int gdriver, gmode, gerror;

	gdriver = DETECT;
	detectgraph(&gdriver,&gmode);
	initgraph(&gdriver,&gmode,"");

	xsize = getmaxx();
	ysize = getmaxy();
	setviewport(0,0,639,479,1);
	setcolor(white);

}

// This Function Multiplies a 4X4 Matrix with a 4X1 Vector
// Returning the resultant in the vector
void Mat_Mul(vector_ptr v,matrix_ptr m)
{
	float x_new, y_new, z_new;
   x_new = m->elem[0][0]*v->p[0]+m->elem[0][1]*v->p[1]+
           m->elem[0][2]*v->p[2]+m->elem[0][3]*v->p[3];
   y_new = m->elem[1][0]*v->p[0]+m->elem[1][1]*v->p[1]+
           m->elem[1][2]*v->p[2]+m->elem[1][3]*v->p[3];
   z_new = m->elem[2][0]*v->p[0]+m->elem[2][1]*v->p[1]+
           m->elem[2][2]*v->p[2]+m->elem[2][3]*v->p[3];
   v->p[X_COMP] = x_new;
   v->p[Y_COMP] = y_new;
   v->p[Z_COMP] = z_new;
   v->p[N_COMP] = 1.0;
}


// This Function takes a the virtual camera vector
// and creates the Transformation Pipeline Matrix
// TSigma, and returns it in matrix m.
float CR_Sigma(vector_ptr E, matrix_ptr m)
{
   float x,y,z;
	float Theta,Phi,Rho;
   x = E->p[X_COMP];
   y = E->p[Y_COMP];
   z = E->p[Z_COMP];
   Rho = (float) sqrt((double)((x*x)+(y*y)+(z*z)));
   Theta = asin(y/(float)(sqrt((double)((x*x)+(y*y)))));
   Phi =   acos(z/Rho);
   m->elem[0][0] = -sin(Theta);
   m->elem[0][1] = cos(Theta);
   m->elem[0][2] = 0.0;
   m->elem[0][3] = 0.0;
   m->elem[1][0] = -cos(Phi)*cos(Theta);
   m->elem[1][1] = -cos(Phi)*sin(Theta);
   m->elem[1][2] = sin(Phi);
   m->elem[1][3] = 0.0;
   m->elem[2][0] = -sin(Phi)*cos(Theta);
   m->elem[2][1] = -sin(Phi)*sin(Theta);
   m->elem[2][2] = -cos(Phi);
   m->elem[2][3] = Rho;
   m->elem[3][0] = 0.0;
   m->elem[3][1] = 0.0;
   m->elem[3][2] = 0.0;
   m->elem[3][3] = 1.0;
   return Rho;
}


// This Function Sets up the Cube Data Structure
// with a general 25 X 25 X 25 Cube in WCS
void Define_Cube(object_ptr cube)
{
  cube->Point[0].p[X_COMP] = 25.0;
  cube->Point[0].p[Y_COMP] = 0.0;
  cube->Point[0].p[Z_COMP] = 0.0;
  cube->Point[0].p[N_COMP] = 1.0;
  cube->Point[1].p[X_COMP] = 25.0;
  cube->Point[1].p[Y_COMP] = 25.0;
  cube->Point[1].p[Z_COMP] = 0.0;
  cube->Point[1].p[N_COMP] = 1.0;
  cube->Point[2].p[X_COMP] = 25.0;
  cube->Point[2].p[Y_COMP] = 25.0;
  cube->Point[2].p[Z_COMP] = 25.0;
  cube->Point[2].p[N_COMP] = 1.0;
  cube->Point[3].p[X_COMP] = 25.0;
  cube->Point[3].p[Y_COMP] = 0.0;
  cube->Point[3].p[Z_COMP] = 25.0;
  cube->Point[3].p[N_COMP] = 1.0;
  cube->Point[4].p[X_COMP] = 25.0;
  cube->Point[4].p[Y_COMP] = 0.0;
  cube->Point[4].p[Z_COMP] = 0.0;
  cube->Point[4].p[N_COMP] = 1.0;
  cube->Point[5].p[X_COMP] = 25.0;
  cube->Point[5].p[Y_COMP] = 0.0;
  cube->Point[5].p[Z_COMP] = 25.0;
  cube->Point[5].p[N_COMP] = 1.0;
  cube->Point[6].p[X_COMP] = 25.0;
  cube->Point[6].p[Y_COMP] = 25.0;
  cube->Point[6].p[Z_COMP] = 25.0;
  cube->Point[6].p[N_COMP] = 1.0;
  cube->Point[7].p[X_COMP] = 0.0;
  cube->Point[7].p[Y_COMP] = 25.0;
  cube->Point[7].p[Z_COMP] = 25.0;
  cube->Point[7].p[N_COMP] = 1.0;
  cube->Point[8].p[X_COMP] = 0.0;
  cube->Point[8].p[Y_COMP] = 0.0;
  cube->Point[8].p[Z_COMP] = 25.0;
  cube->Point[8].p[N_COMP] = 1.0;
  cube->Point[9].p[X_COMP] = 25.0;
  cube->Point[9].p[Y_COMP] = 0.0;
  cube->Point[9].p[Z_COMP] = 25.0;
  cube->Point[9].p[N_COMP] = 1.0;
  cube->Point[10].p[X_COMP] = 25.0;
  cube->Point[10].p[Y_COMP] = 25.0;
  cube->Point[10].p[Z_COMP] = 0.0;
  cube->Point[10].p[N_COMP] = 1.0;
  cube->Point[11].p[X_COMP] = 0.0;
  cube->Point[11].p[Y_COMP] = 25.0;
  cube->Point[11].p[Z_COMP] = 0.0;
  cube->Point[11].p[N_COMP] = 1.0;
  cube->Point[12].p[X_COMP] = 0.0;
  cube->Point[12].p[Y_COMP] = 25.0;
  cube->Point[12].p[Z_COMP] = 25.0;
  cube->Point[12].p[N_COMP] = 1.0;
  cube->Point[13].p[X_COMP] = 25.0;
  cube->Point[13].p[Y_COMP] = 25.0;
  cube->Point[13].p[Z_COMP] = 25.0;
  cube->Point[13].p[N_COMP] = 1.0;
  cube->Point[14].p[X_COMP] = 25.0;
  cube->Point[14].p[Y_COMP] = 25.0;
  cube->Point[14].p[Z_COMP] = 0.0;
  cube->Point[14].p[N_COMP] = 1.0;
}


// This Function Takes an Object and draws a
// polygon from the values found in the X and
// Y Components of the Object. number is the
// number of vertexes to draw.
void Draw_Object(object_ptr poly, int number)
{
 int Temp[500][2];
 int index;
 for (index=0; index<=number; index++)
 {
  Temp[index][0] = (int) poly->Point[index].p[0];
  Temp[index][1] = (int) poly->Point[index].p[1];
 }
 Temp[index][0] = Temp[0][0];
 Temp[index][1] = Temp[0][1];
 drawpoly(number+1, (int far *)Temp);
}

// This Function Takes an Object and fills a
// polygon from the values found in the X and
// Y Components of the Object. number is the
// number of vertexes of the Polygon. it uses a
// Hybrid Parity Fill Routine
void Fill_Object(object_ptr poly, int number)
{
 int Temp[500][2];
 int index;
 for (index=0; index<=number; index++)
 {
  Temp[index][0] = (int) poly->Point[index].p[0];
  Temp[index][1] = (int) poly->Point[index].p[1];
 }
 Temp[index][0] = Temp[0][0];
 Temp[index][1] = Temp[0][1];
 fillpoly(number+1, (int far *)Temp);
}


// This Performs the World to Viewer Coordinate Transformation
// By Multiplying the incoming vector with the Matrix TSigma
// Number is the number of verticies in the Object to be transformed
void World_Viewer(object_ptr poly, matrix_ptr TSig, int number)
{
 	int index;
   for (index=0;index<=number;index++)
   {
      Mat_Mul((vector_ptr)&poly->Point[index],TSig);
   }
}

// This Procedure performs both the Perspective Projection
// Step and the conversion to screen coordinates step in one
// sweep. the Object is converted with number being the number
// of vertices and d being the Distance to the projection plane.
void Viewer_Project(object_ptr poly, int number, int d)
{
  int index;
  for (index=0;index<=number;index++)
  {
  	poly->Point[index].p[X_COMP] =
   	poly->Point[index].p[X_COMP]*d/poly->Point[index].p[Z_COMP]+320.0;
  	poly->Point[index].p[Y_COMP] =(480-(
   	poly->Point[index].p[Y_COMP]*d/poly->Point[index].p[Z_COMP]+240.0));
  	poly->Point[index].p[Z_COMP] = d;

  }
}


// This Procedure Converts 2d Maps into 3d Fields with values set for
//field specified by POS X=0 Y=1 Z=2. That is , X,Y,or Z Position
// will be constand with a value specified by the variable value.
void TwoD_ThreeD(object_ptr poly,int number,maptype_ptr mapname,
						float value,int Pos,int horiz,int vert)
{
 int index;

 switch(Pos)
 {
 	case X_COMP:
   {
 	for (index=0;index<=number;index++)
	 {
 	 poly->Point[index].p[X_COMP] = value;
  	 poly->Point[index].p[Y_COMP] = (float)mapname->Vertex[index][X_COMP];
  	 poly->Point[index].p[Z_COMP] = (float)mapname->Vertex[index][Y_COMP];
    poly->Point[index].p[N_COMP] = 1.0;
 	};
   } break;
 	case Y_COMP:
   {
 	for (index=0;index<=number;index++)
 	{
 	 poly->Point[index].p[X_COMP]=horiz-((float)mapname->Vertex[index][X_COMP]);
  	 poly->Point[index].p[Y_COMP] = value;
  	 poly->Point[index].p[Z_COMP] = (float)mapname->Vertex[index][Y_COMP];
    poly->Point[index].p[N_COMP] = 1.0;
 	};
   } break;
 	case Z_COMP:
   {
 	for (index=0;index<=number;index++)
 	{
 	 poly->Point[index].p[X_COMP] =vert-((float)mapname->Vertex[index][Y_COMP]);
  	 poly->Point[index].p[Y_COMP] = (float)mapname->Vertex[index][X_COMP];
  	 poly->Point[index].p[Z_COMP] = value;
    poly->Point[index].p[N_COMP] = 1.0;
   };
   } break;
 } // End Switch
} // End 2d to 3d

// This Routine Takes an Object (Not Necessarily a cube) IN WCS
// Format and performs a linear Translation by the X,Y,Z inputs
void Translate_Cube(object_ptr cube,int x, int y, int z,int number)
{
 int index;
 for (index=0;index<=number;index++)
 {
 	cube->Point[index].p[X_COMP]=cube->Point[index].p[X_COMP]+x;
   cube->Point[index].p[Y_COMP]=cube->Point[index].p[Y_COMP]+y;
	cube->Point[index].p[Z_COMP]=cube->Point[index].p[Z_COMP]+z;
 }
}


// This Routine Draws an X and Y Line (Green) and Fills the enclosed
// region for use as a Ground PLane for the Texas Map and Shadow Casting
void Draw_Axes(matrix_ptr TSigma)
{
 int index;
 axesob Axes;
 setcolor(green);

 Axes.Point[0].p[X_COMP]=-600.0;
 Axes.Point[0].p[Y_COMP]=-275.0;
 Axes.Point[0].p[Z_COMP]=0.0;
 Axes.Point[0].p[N_COMP]=1.0;

 Axes.Point[1].p[X_COMP]=600.0;
 Axes.Point[1].p[Y_COMP]=-275.0;
 Axes.Point[1].p[Z_COMP]=0.0;
 Axes.Point[1].p[N_COMP]=1.0;

 Axes.Point[2].p[X_COMP]=-300.0;
 Axes.Point[2].p[Y_COMP]=-600.0;
 Axes.Point[2].p[Z_COMP]=0.0;
 Axes.Point[2].p[N_COMP]=1.0;

 Axes.Point[3].p[X_COMP]=-300.0;
 Axes.Point[3].p[Y_COMP]=600.0;
 Axes.Point[3].p[Z_COMP]=0.0;
 Axes.Point[3].p[N_COMP]=1.0;

 // note Point[4] not used (Testing)
 Axes.Point[4].p[X_COMP]=0.0;
 Axes.Point[4].p[Y_COMP]=0.0;
 Axes.Point[4].p[Z_COMP]=0.0;
 Axes.Point[4].p[N_COMP]=1.0;

 // note Point[5] not Used (Testing)
 Axes.Point[5].p[X_COMP]=0.0;
 Axes.Point[5].p[Y_COMP]=0.0;
 Axes.Point[5].p[Z_COMP]=-1600.0;
 Axes.Point[5].p[N_COMP]=1.0;

 // Change from WCS to SCS
 World_Viewer((object_ptr)&Axes,TSigma,5);
 Viewer_Project((object_ptr)&Axes,5,300);
 for (index=0;index<=3;index=index+2)
 {
 	moveto((int)Axes.Point[index].p[X_COMP],(int)Axes.Point[index].p[Y_COMP]);
   lineto((int)Axes.Point[index+1].p[X_COMP],(int)Axes.Point[index+1].p[Y_COMP]);
 }
 // Fill GPlane Light Gray
 setfillstyle(1,ltgray);
 floodfill((int)(Axes.Point[0].p[Y_COMP])+2,(int)(Axes.Point[2].p[X_COMP])+2,
 						green);
} // End of Draw Axes

// This Routine Incorporates the General Rotation Matrixes
// with an object in WCS format and an Angle and Axis of rotation
// This routine will return the object rotated about that axis.
// NOTE: World_Viewer is used in this routine, not because a world
// to viewer transformation was needed, but because the routine was
// general enough to be used for another purpose. Perhaps a better
// name for the routine would be Transform_Object.
void Rotate_Object_WCS(object_ptr wcsob,int number,int RAxis,int Degrees)
{
 matrix Rotate_Matrix;
 float Rads;
 Rads = (Degrees*3.14)/180.0;
 switch (RAxis)
 {
  case X_COMP:
  {
    // Set up Rotation Matrix about X
    Rotate_Matrix.elem[0][0] = 1.0;
    Rotate_Matrix.elem[0][1] = 0.0;
    Rotate_Matrix.elem[0][2] = 0.0;
    Rotate_Matrix.elem[0][3] = 0.0;
    Rotate_Matrix.elem[1][0] = 0.0;
    Rotate_Matrix.elem[1][1] = cos(Rads);
    Rotate_Matrix.elem[1][2] = sin(Rads);
    Rotate_Matrix.elem[1][3] = 0.0;
    Rotate_Matrix.elem[2][0] = 0.0;
    Rotate_Matrix.elem[2][1] = -sin(Rads);
    Rotate_Matrix.elem[2][2] = cos(Rads);
    Rotate_Matrix.elem[2][3] = 0.0;
    Rotate_Matrix.elem[3][0] = 0.0;
    Rotate_Matrix.elem[3][1] = 0.0;
    Rotate_Matrix.elem[3][2] = 0.0;
    Rotate_Matrix.elem[3][3] = 1.0;
  };
  break;
  case Y_COMP:
  {
   // Set up Rotation Matrix About Y
    Rotate_Matrix.elem[0][0] = cos(Rads);
    Rotate_Matrix.elem[0][1] = 0.0;
    Rotate_Matrix.elem[0][2] = sin(Rads);
    Rotate_Matrix.elem[0][3] = 0.0;
    Rotate_Matrix.elem[1][0] = 0.0;
    Rotate_Matrix.elem[1][1] = 1.0;
    Rotate_Matrix.elem[1][2] = 0.0;
    Rotate_Matrix.elem[1][3] = 0.0;
    Rotate_Matrix.elem[2][0] = -sin(Rads);
    Rotate_Matrix.elem[2][1] = 0.0;
    Rotate_Matrix.elem[2][2] = cos(Rads);
    Rotate_Matrix.elem[2][3] = 0.0;
    Rotate_Matrix.elem[3][0] = 0.0;
    Rotate_Matrix.elem[3][1] = 0.0;
    Rotate_Matrix.elem[3][2] = 0.0;
    Rotate_Matrix.elem[3][3] = 1.0;
  };
  break;
  case Z_COMP:
  {
   // Setup Rotation Matrix About Z
    Rotate_Matrix.elem[0][0] = cos(Rads);
    Rotate_Matrix.elem[0][1] = sin(Rads);
    Rotate_Matrix.elem[0][2] = 0.0;
    Rotate_Matrix.elem[0][3] = 0.0;
    Rotate_Matrix.elem[1][0] = -sin(Rads);
    Rotate_Matrix.elem[1][1] = cos(Rads);
    Rotate_Matrix.elem[1][2] = 0.0;
    Rotate_Matrix.elem[1][3] = 0.0;
    Rotate_Matrix.elem[2][0] = 0.0;
    Rotate_Matrix.elem[2][1] = 0.0;
    Rotate_Matrix.elem[2][2] = 1.0;
    Rotate_Matrix.elem[2][3] = 0.0;
    Rotate_Matrix.elem[3][0] = 0.0;
    Rotate_Matrix.elem[3][1] = 0.0;
    Rotate_Matrix.elem[3][2] = 0.0;
    Rotate_Matrix.elem[3][3] = 1.0;
  };
  break;
 }

 World_Viewer(wcsob,(matrix_ptr)&Rotate_Matrix,number);
 // not really a world to viewer transformation, but the routine performs
 // the services necessary.

}

// THis Routine Takes a Cube, Light Source, and Transformation Pipeline Info
// as input, and Draws the Shadow Projected on the XY Plane by the TOP of the
// cube.
// Note: A little more code and all faces could have been projected for a more
// realistic Shadowing effect. (Time Constraint)
void Project_Shadow(object_ptr cube,vector_ptr Light_Source,matrix_ptr TSigma,
							int d)
{
 shadow Shad; //  A Shadow Object)
 vector Dirvect;  // Direction Vector
 int index;
 float lambda;    // Scaling Factor for Vector Line Representation
 float Xc,Yc,Zc; // Alias for a Point on the Cube
 float XSeed,YSeed; // The Seed Values for Shadow
 float Xmin,Xmax,Ymin,Ymax; // Used in Seed Value Calculation
 Xmin = 1000;
 Ymin = 1000;
 Xmax = 0;
 Ymax = 0;
 for (index=5;index<=9;index++)
 {

   // Standard Vector Representation to Solve
   // .P0. + Lambda(.D0.) = .P1.
  	Xc = cube->Point[index].p[X_COMP];
   Yc = cube->Point[index].p[Y_COMP];
   Zc = cube->Point[index].p[Z_COMP];
   Dirvect.p[X_COMP] = Light_Source->p[X_COMP]-Xc;
   Dirvect.p[Y_COMP] = Light_Source->p[Y_COMP]-Yc;
   Dirvect.p[Z_COMP] = Light_Source->p[Z_COMP]-Zc;
   lambda = -Zc/Dirvect.p[Z_COMP];
   Shad.Point[index-5].p[X_COMP] = Xc+lambda*Dirvect.p[X_COMP];
   Shad.Point[index-5].p[Y_COMP] = Yc+lambda*Dirvect.p[Y_COMP];
   Shad.Point[index-5].p[Z_COMP] = 0.0;
   Shad.Point[index-5].p[N_COMP] = 1.0;
}

   // Xformation Pipeline on Shadow in WCS.
   World_Viewer((object_ptr)&Shad,TSigma,4);
  	Viewer_Project((object_ptr)&Shad,4,d);
   Draw_Object((object_ptr)&Shad,4);

   // Find a point inside the Square for filling Shadow
   // An example of yet another method of finding a seed point
   // I could have transformed the old seed point, but since this is
   // a square I hardly think that the extra computation is necessary.
   for (index=0;index <=4;index++)
   {
   if (Shad.Point[index].p[X_COMP] < Xmin)
   	Xmin = Shad.Point[index].p[X_COMP];
   if (Shad.Point[index].p[X_COMP] > Xmax)
   	Xmax = Shad.Point[index].p[X_COMP];
   if (Shad.Point[index].p[Y_COMP] < Ymin)
   	Ymin = Shad.Point[index].p[Y_COMP];
   if (Shad.Point[index].p[Y_COMP] > Ymax)
   	Ymax = Shad.Point[index].p[Y_COMP];
   }
   XSeed = Xmin+(Xmax-Xmin)/2.0;
   YSeed = Ymin+(Ymax-Ymin)/2.0;
   setfillstyle(1,dkgray);
   floodfill(XSeed,YSeed,
    dkgray);
} // END OF SHADOW_PROJECT

// **********************END OF CODE**************************************
