#include <io.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <bios.h>
#include <fcntl.h>
#include <memory.h>
#include <math.h>
#include <string.h>

#define VGA256					0x13
#define TEXT_MODE    		0x03

#define PALETTE_MASK    	0x3c6
#define PALETTE_REGISTER   0x3c8
#define PALETTE_DATA			0x3c9

#define SCREEN_WIDTH			(unsigned int)320
#define SCREEN_HEIGHT		(unsigned int)200

typedef struct RGB_color_typ
{
	unsigned char red;
	unsigned char green;
	unsigned char blue;
} RGB_color, *RGB_color_ptr;

extern void Set_Mode(int mode);

void Set_Palette_Register(int index, RGB_color_ptr color);
void Get_Palette_Register(int index, RGB_color_ptr color);
void Create_Cool_Palette(void);
void V_Line(int y1, int y2, int x, unsigned int color);
unsigned char far *video_buffer = (char far *)0xA0000000L;
// vram byte ptr
unsigned int far *video_buffer_w= (int far *) 0xA0000000L;
// vram word ptr

void Set_Palette_Register(int index, RGB_color_ptr color)
{
	outp(PALETTE_MASK,0xff);
	outp(PALETTE_REGISTER, index);
	outp(PALETTE_DATA,color->red);
	outp(PALETTE_DATA,color->green);
	outp(PALETTE_DATA,color->blue);
}

void Get_Palette_Register(int index, RGB_color_ptr color)
{
	outp(PALETTE_MASK,0xff);
	outp(PALETTE_REGISTER, index);
	color->red = inp(PALETTE_DATA);
	color->green = inp(PALETTE_DATA);
	color->blue = inp(PALETTE_DATA);
}

void Create_Cool_Palette(void)
{
	RGB_color color;
	int index;

	for(index = 0;index<64;index++)
	{
		color.red   = index;
		color.green = index;
		color.blue  = index;

		Set_Palette_Register(index, (RGB_color_ptr)&color);

		color.red   = index;
		color.green = 0;
		color.blue  = 0;

		Set_Palette_Register(index+64, (RGB_color_ptr)&color);

		color.red   = 0;
		color.green = index;
		color.blue  = 0;

		Set_Palette_Register(index+128, (RGB_color_ptr)&color);

		color.red   = 0;
		color.green = 0;
		color.blue  = index;

		Set_Palette_Register(index+192, (RGB_color_ptr)&color);
	}
}

void V_Line(int y1, int y2, int x, unsigned int color)
{
	unsigned int line_offset, index;

	line_offset = ((y1<<8) + (y1<<6))+x;
	for(index=0;index<=y2-y1;index++)
	{
		video_buffer[line_offset] = color;
		line_offset += 320;
	}
}

void main(void)
{
	int index;
	RGB_color color, color_1;

	Set_Mode(VGA256);

	Create_Cool_Palette();

	for(index=0;index<320;index++)
		V_Line(0,199,index,index);

	while(!kbhit())
	{
		Get_Palette_Register(0,(RGB_color_ptr)&color_1);
		Get_Palette_Register(0,(RGB_color_ptr)&color_1);

		for(index=0; index<=254; index++)
		{
			Get_Palette_Register(index+1, (RGB_color_ptr)&color);
			Get_Palette_Register(index+1, (RGB_color_ptr)&color);
			Set_Palette_Register(index, (RGB_color_ptr)&color);
		}
		Set_Palette_Register(255, (RGB_color_ptr)&color_1);
	}
	Set_Mode(TEXT_MODE);
}

