#include <stdio.h>
#include <math.h>
#include <graphics.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#define blue 1
#define white 15
#define red 4
#define construct 12
#define green 2
#define black 0
#define X_COMP 0
#define Y_COMP 1
#define Z_COMP 2
#define N_COMP 3


typedef struct vector_type
{
 float p[4]; // a 3d point with normalizing vector
} vector, *vector_ptr;

typedef struct matrix_type
{
 float elem[4][4];
} matrix, *matrix_ptr;

typedef struct object_type
{
 vector Point[500];
} object, *object_ptr;

typedef struct seedob_type
{
 vector Point[3];
} seedob, *seedob_ptr;

typedef struct map_type
{
 int Vertex[500][2];
} maptype, *maptype_ptr;

typedef struct tt_type
{
 int Vertex[26][2];
} tttype, *tttype_ptr;

int xsize,ysize;
int bound;


void Mat_Mul(vector_ptr,matrix_ptr);
float CR_Sigma(vector_ptr , matrix_ptr);
void initialize(void);
void Define_Cube(object_ptr);
void Draw_Object(object_ptr,int);
void World_Viewer(object_ptr,matrix_ptr,int);
void Viewer_Project(object_ptr,int,int);
void TwoD_ThreeD(object_ptr,int,maptype_ptr,float,int,int,int);

main()
{
   int mx,my;
//   float maxx,maxy,minx,miny;
   float d;
   float rho;
   float x,y;
   int junk;
   int index,numpts;
   vector Evect;
	matrix TSigma;
   seedob CubeSeeds; //0 Left, 1 Top 2 Right
   seedob TexasSeeds; // 0 Left, 1 Top, 2 Right
   seedob TTSeeds;   //0 Left, 1 Top, 2 Right
	object Cube; // a standard Cube (0,0,0) to (100,100,100)
   object Map;
   object Dout;
   tttype dout;
	maptype map;

   FILE *mapfile;
   initialize();
//   maxx=0.0;
//   maxy=0.0;
//   minx=1000.0;
//   miny=1000.0;
   Evect.p[X_COMP]=200.0;
   Evect.p[Y_COMP]=200.0;
   Evect.p[Z_COMP]=282.8;
   Evect.p[N_COMP]=1.0;
   CubeSeeds.Point[0].p[X_COMP] = 100.0;
   CubeSeeds.Point[0].p[Y_COMP] = 50.0;
   CubeSeeds.Point[0].p[Z_COMP] = 50.0;
   CubeSeeds.Point[0].p[N_COMP] = 1.0;
   CubeSeeds.Point[1].p[X_COMP] = 50.0;
   CubeSeeds.Point[1].p[Y_COMP] = 50.0;
   CubeSeeds.Point[1].p[Z_COMP] = 100.0;
   CubeSeeds.Point[1].p[N_COMP] = 1.0;
   CubeSeeds.Point[2].p[X_COMP] = 50.0;
   CubeSeeds.Point[2].p[Y_COMP] = 100.0;
   CubeSeeds.Point[2].p[Z_COMP] = 50.0;
   CubeSeeds.Point[2].p[N_COMP] = 1.0;
   TexasSeeds.Point[0].p[X_COMP] = 100.0;
   TexasSeeds.Point[0].p[Y_COMP] = 50.0;
   TexasSeeds.Point[0].p[Z_COMP] = 50.0;
   TexasSeeds.Point[0].p[N_COMP] = 1.0;
   TexasSeeds.Point[1].p[X_COMP] = 50.0;
   TexasSeeds.Point[1].p[Y_COMP] = 50.0;
   TexasSeeds.Point[1].p[Z_COMP] = 100.0;
   TexasSeeds.Point[1].p[N_COMP] = 1.0;
   TexasSeeds.Point[2].p[X_COMP] = 50.0;
   TexasSeeds.Point[2].p[Y_COMP] = 100.0;
   TexasSeeds.Point[2].p[Z_COMP] = 50.0;
   TexasSeeds.Point[2].p[N_COMP] = 1.0;
   TTSeeds.Point[0].p[X_COMP]=100.0;
   TTSeeds.Point[0].p[Y_COMP]=9.0;
   TTSeeds.Point[0].p[Z_COMP]=9.0;
   TTSeeds.Point[0].p[N_COMP]=1.0;
   TTSeeds.Point[1].p[X_COMP]=9.0;
   TTSeeds.Point[1].p[Y_COMP]=9.0;
   TTSeeds.Point[1].p[Z_COMP]=100.0;
   TTSeeds.Point[1].p[N_COMP]=1.0;
   TTSeeds.Point[2].p[X_COMP]=9.0;
   TTSeeds.Point[2].p[Y_COMP]=100.0;
   TTSeeds.Point[2].p[Z_COMP]=9.0;
   TTSeeds.Point[2].p[N_COMP]=1.0;


   	// Set Double T Structure with general T
  	dout.Vertex[0][0] =0;
	dout.Vertex[0][1] =0;
	dout.Vertex[1][0] =18;
	dout.Vertex[1][1] =0;
	dout.Vertex[2][0] =18;
	dout.Vertex[2][1] =5;
	dout.Vertex[3][0] =14;
	dout.Vertex[3][1] =5;
	dout.Vertex[4][0] =14;
	dout.Vertex[4][1] =4;
	dout.Vertex[5][0] =11;
	dout.Vertex[5][1] =4;
	dout.Vertex[6][0] =11;
	dout.Vertex[6][1] =7;
	dout.Vertex[7][0] =15;
	dout.Vertex[7][1] =7;
	dout.Vertex[8][0] =15;
	dout.Vertex[8][1] =10;
	dout.Vertex[9][0] =11;
	dout.Vertex[9][1] =10;
	dout.Vertex[10][0]=11;
	dout.Vertex[10][1]=17;
	dout.Vertex[11][0]=13;
	dout.Vertex[11][1]=17;
	dout.Vertex[12][0]=13;
	dout.Vertex[12][1]=20;
	dout.Vertex[13][0]=5;
	dout.Vertex[13][1]=20;
	dout.Vertex[14][0]=5;
	dout.Vertex[14][1]=17;
	dout.Vertex[15][0]=7;
	dout.Vertex[15][1]=17;
	dout.Vertex[16][0]=7;
	dout.Vertex[16][1]=10;
	dout.Vertex[17][0]=3;
	dout.Vertex[17][1]=10;
	dout.Vertex[18][0]=3;
	dout.Vertex[18][1]=7;
	dout.Vertex[19][0]=7;
	dout.Vertex[19][1]=7;
	dout.Vertex[20][0]=7;
	dout.Vertex[20][1]=4;
	dout.Vertex[21][0]=4;
	dout.Vertex[21][1]=4;
	dout.Vertex[22][0]=4;
	dout.Vertex[22][1]=5;
	dout.Vertex[23][0]=0;
	dout.Vertex[23][1]=5;
	dout.Vertex[24][0]=dout.Vertex[0][0];
	dout.Vertex[24][1]=dout.Vertex[0][1];
   index=0;
   mx=0;
   my=0;
   for (index = 0;index<=24;index++)
   {
    dout.Vertex[index][0] = 2*(dout.Vertex[index][0])+4;
    dout.Vertex[index][1] = 2*(20-dout.Vertex[index][1])+4;
   }
   index=0;
	setviewport(0,0,639,479,1);
   mapfile = fopen("texas.map","r");
	while(fscanf(mapfile,"%f %f %d",&x,&y,&junk) !=EOF)
	{
		map.Vertex[index][0] = x;
		map.Vertex[index][1] = y;
		if (x > mx) mx = x;
		if (y > my) my = y;
		index++;
	}
	numpts = index;

	map.Vertex[numpts][0] = map.Vertex[0][0];
	map.Vertex[numpts][1] = map.Vertex[0][1];

   bound = xsize/4.5;
	for(index=0;index<=numpts;index++)
	{
		map.Vertex[index][0] = ((float)map.Vertex[index][0]/mx*(xsize-bound))*0.2;
		map.Vertex[index][1] = ysize-(map.Vertex[index][1]/(float)my*ysize)*0.2;
		map.Vertex[index][0] = map.Vertex[index][0] + (xsize - bound)*0.1;
		map.Vertex[index][1] = map.Vertex[index][1] - ysize*0.15;
		map.Vertex[index][0] = map.Vertex[index][0] - 50.0;
		map.Vertex[index][1] = 480-(map.Vertex[index][1]+76) ;
//      if (map.Vertex[index][0] > maxx) maxx = map.Vertex[index][0];
//      if (map.Vertex[index][1] > maxy) maxy = map.Vertex[index][1];
//      if (map.Vertex[index][0] < minx) minx = map.Vertex[index][0];
//      if (map.Vertex[index][1] < miny) miny = map.Vertex[index][1];
	}

//   drawpoly(numpts, (int far *)map.Vertex);
//   drawpoly(25,(int far*)dout.Vertex);
   setcolor(white);
   Define_Cube((object_ptr)&Cube);
  	rho = CR_Sigma((vector_ptr)&Evect,(matrix_ptr)&TSigma);
  	d = 600;
   World_Viewer((object_ptr)&Cube,(matrix_ptr)&TSigma,14);
  	Viewer_Project((object_ptr)&Cube,14,d);
   Draw_Object((object_ptr)&Cube,14);
   World_Viewer((object_ptr)&CubeSeeds,(matrix_ptr)&TSigma,2);
   Viewer_Project((object_ptr)&CubeSeeds,2,d);
   setfillstyle(1,blue);
	floodfill(CubeSeeds.Point[0].p[X_COMP],CubeSeeds.Point[0].p[Y_COMP], white);
   setfillstyle(1,white);
	floodfill(CubeSeeds.Point[1].p[X_COMP],CubeSeeds.Point[1].p[Y_COMP], white);
	setfillstyle(1,red);
	floodfill(CubeSeeds.Point[2].p[X_COMP],CubeSeeds.Point[2].p[Y_COMP], white);

   World_Viewer((object_ptr)&TexasSeeds,(matrix_ptr)&TSigma,2);
   Viewer_Project((object_ptr)&TexasSeeds,2,d);

   setcolor(black);
   TwoD_ThreeD((object_ptr)&Map,numpts,(maptype_ptr)&map,100.0,X_COMP,98,96);
   World_Viewer((object_ptr)&Map,(matrix_ptr)&TSigma,numpts);
  	Viewer_Project((object_ptr)&Map,numpts,d);
   Draw_Object((object_ptr)&Map,numpts);
   floodfill(TexasSeeds.Point[0].p[X_COMP],TexasSeeds.Point[0].p[Y_COMP], 0);

//   setcolor(white);
   TwoD_ThreeD((object_ptr)&Map,numpts,(maptype_ptr)&map,100.0,Y_COMP,98,96);
   World_Viewer((object_ptr)&Map,(matrix_ptr)&TSigma,numpts);
  	Viewer_Project((object_ptr)&Map,numpts,d);
   Draw_Object((object_ptr)&Map,numpts);
	setfillstyle(1,white);
	floodfill(TexasSeeds.Point[2].p[X_COMP],TexasSeeds.Point[2].p[Y_COMP],0);

//   setcolor(blue);
   TwoD_ThreeD((object_ptr)&Map,numpts,(maptype_ptr)&map,100.0,Z_COMP,98,96);
   World_Viewer((object_ptr)&Map,(matrix_ptr)&TSigma,numpts);
  	Viewer_Project((object_ptr)&Map,numpts,d);
   Draw_Object((object_ptr)&Map,numpts);
 	setfillstyle(1,blue);
	floodfill(TexasSeeds.Point[1].p[X_COMP],TexasSeeds.Point[1].p[Y_COMP],0);

   setcolor(green);
   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,100.0,X_COMP,98,96);
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
   Viewer_Project((object_ptr)&Dout,24,d);
   Draw_Object((object_ptr)&Dout,25);
   setfillstyle(1,black);
/*   floodfill((int)(Dout.Point[0].p[X_COMP]+2),(int)(Dout.Point[0].p[Y_COMP]+2),green);
   floodfill((int)(Dout.Point[0].p[X_COMP]+10),
             (int)(Dout.Point[1].p[Y_COMP]-25),green);
//   circle((int)(Dout.Point[0].p[X_COMP]+10),
//          (int)(Dout.Point[1].p[Y_COMP]-25),5); */

   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,100.0,Y_COMP,98,/*40*/96);
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
   Viewer_Project((object_ptr)&Dout,24,d);
   Draw_Object((object_ptr)&Dout,25);


   TwoD_ThreeD((object_ptr)&Dout,24,(maptype_ptr)&dout,100.0,Z_COMP,98,/*100*/96);
   World_Viewer((object_ptr)&Dout,(matrix_ptr)&TSigma,24);
   Viewer_Project((object_ptr)&Dout,24,d);
   Draw_Object((object_ptr)&Dout,25);

   getch();
   fclose(mapfile);
	closegraph();

//   printf("Maxx: %f Minx: %f\n",maxx,minx);
//   printf("Maxy: %f Miny: %f\n",maxy,miny);
//   printf("XSize: %f YSize: %f\n",maxx-minx,maxy-miny);
//   printf(" |%f  %f  %f  %f|\n", TSigma.elem[0][0],TSigma.elem[0][1],
//   		TSigma.elem[0][2],TSigma.elem[0][3]);
//   printf(" |%f  %f  %f  %f|\n", TSigma.elem[1][0],TSigma.elem[1][1],
//   		TSigma.elem[1][2],TSigma.elem[1][3]);
//   printf(" |%f  %f  %f  %f|\n", TSigma.elem[2][0],TSigma.elem[2][1],
//   		TSigma.elem[2][2],TSigma.elem[2][3]);
//   printf(" |%f  %f  %f  %f|\n", TSigma.elem[3][0],TSigma.elem[3][1],
//   		TSigma.elem[3][2],TSigma.elem[3][3]);

} // End of Main



void initialize(void)
{
	int gdriver, gmode, gerror;

	gdriver = DETECT;
	detectgraph(&gdriver,&gmode);
	initgraph(&gdriver,&gmode,"");

	xsize = getmaxx();
	ysize = getmaxy();
}

void Mat_Mul(vector_ptr v,matrix_ptr m)
{
	float x_new, y_new, z_new;
   x_new = m->elem[0][0]*v->p[0]+m->elem[0][1]*v->p[1]+
           m->elem[0][2]*v->p[2]+m->elem[0][3]*v->p[3];
   y_new = m->elem[1][0]*v->p[0]+m->elem[1][1]*v->p[1]+
           m->elem[1][2]*v->p[2]+m->elem[1][3]*v->p[3];
   z_new = m->elem[2][0]*v->p[0]+m->elem[2][1]*v->p[1]+
           m->elem[2][2]*v->p[2]+m->elem[2][3]*v->p[3];
   v->p[X_COMP] = x_new;
   v->p[Y_COMP] = y_new;
   v->p[Z_COMP] = z_new;
   v->p[N_COMP] = 1.0;
}

float CR_Sigma(vector_ptr E, matrix_ptr m)
{
   float x,y,z;
	float Theta,Phi,Rho;
   x = E->p[X_COMP];
   y = E->p[Y_COMP];
   z = E->p[Z_COMP];
   Rho = (float) sqrt((double)((x*x)+(y*y)+(z*z)));
   Theta = asin(y/(float)(sqrt((double)((x*x)+(y*y)))));
   Phi =   acos(z/Rho);
   m->elem[0][0] = -sin(Theta);
   m->elem[0][1] = cos(Theta);
   m->elem[0][2] = 0.0;
   m->elem[0][3] = 0.0;
   m->elem[1][0] = -cos(Phi)*cos(Theta);
   m->elem[1][1] = -cos(Phi)*sin(Theta);
   m->elem[1][2] = sin(Phi);
   m->elem[1][3] = 0.0;
   m->elem[2][0] = -sin(Phi)*cos(Theta);
   m->elem[2][1] = -sin(Phi)*sin(Theta);
   m->elem[2][2] = -cos(Phi);
   m->elem[2][3] = Rho;
   m->elem[3][0] = 0.0;
   m->elem[3][1] = 0.0;
   m->elem[3][2] = 0.0;
   m->elem[3][3] = 1.0;
   return Rho;
}

void Define_Cube(object_ptr cube)
{
  cube->Point[0].p[X_COMP] = 100.0;
  cube->Point[0].p[Y_COMP] = 0.0;
  cube->Point[0].p[Z_COMP] = 0.0;
  cube->Point[0].p[N_COMP] = 1.0;
  cube->Point[1].p[X_COMP] = 100.0;
  cube->Point[1].p[Y_COMP] = 100.0;
  cube->Point[1].p[Z_COMP] = 0.0;
  cube->Point[1].p[N_COMP] = 1.0;
  cube->Point[2].p[X_COMP] = 100.0;
  cube->Point[2].p[Y_COMP] = 100.0;
  cube->Point[2].p[Z_COMP] = 100.0;
  cube->Point[2].p[N_COMP] = 1.0;
  cube->Point[3].p[X_COMP] = 100.0;
  cube->Point[3].p[Y_COMP] = 0.0;
  cube->Point[3].p[Z_COMP] = 100.0;
  cube->Point[3].p[N_COMP] = 1.0;
  cube->Point[4].p[X_COMP] = 100.0;
  cube->Point[4].p[Y_COMP] = 0.0;
  cube->Point[4].p[Z_COMP] = 0.0;
  cube->Point[4].p[N_COMP] = 1.0;
  cube->Point[5].p[X_COMP] = 100.0;
  cube->Point[5].p[Y_COMP] = 0.0;
  cube->Point[5].p[Z_COMP] = 100.0;
  cube->Point[5].p[N_COMP] = 1.0;
  cube->Point[6].p[X_COMP] = 100.0;
  cube->Point[6].p[Y_COMP] = 100.0;
  cube->Point[6].p[Z_COMP] = 100.0;
  cube->Point[6].p[N_COMP] = 1.0;
  cube->Point[7].p[X_COMP] = 0.0;
  cube->Point[7].p[Y_COMP] = 100.0;
  cube->Point[7].p[Z_COMP] = 100.0;
  cube->Point[7].p[N_COMP] = 1.0;
  cube->Point[8].p[X_COMP] = 0.0;
  cube->Point[8].p[Y_COMP] = 0.0;
  cube->Point[8].p[Z_COMP] = 100.0;
  cube->Point[8].p[N_COMP] = 1.0;
  cube->Point[9].p[X_COMP] = 100.0;
  cube->Point[9].p[Y_COMP] = 0.0;
  cube->Point[9].p[Z_COMP] = 100.0;
  cube->Point[9].p[N_COMP] = 1.0;
  cube->Point[10].p[X_COMP] = 100.0;
  cube->Point[10].p[Y_COMP] = 100.0;
  cube->Point[10].p[Z_COMP] = 0.0;
  cube->Point[10].p[N_COMP] = 1.0;
  cube->Point[11].p[X_COMP] = 0.0;
  cube->Point[11].p[Y_COMP] = 100.0;
  cube->Point[11].p[Z_COMP] = 0.0;
  cube->Point[11].p[N_COMP] = 1.0;
  cube->Point[12].p[X_COMP] = 0.0;
  cube->Point[12].p[Y_COMP] = 100.0;
  cube->Point[12].p[Z_COMP] = 100.0;
  cube->Point[12].p[N_COMP] = 1.0;
  cube->Point[13].p[X_COMP] = 100.0;
  cube->Point[13].p[Y_COMP] = 100.0;
  cube->Point[13].p[Z_COMP] = 100.0;
  cube->Point[13].p[N_COMP] = 1.0;
  cube->Point[14].p[X_COMP] = 100.0;
  cube->Point[14].p[Y_COMP] = 100.0;
  cube->Point[14].p[Z_COMP] = 0.0;
  cube->Point[14].p[N_COMP] = 1.0;
}

void Draw_Object(object_ptr poly, int number)
{
 int Temp[500][2];
 int index;
 for (index=0; index<=number; index++)
 {
  Temp[index][0] = (int) poly->Point[index].p[0];
  Temp[index][1] = (int) poly->Point[index].p[1];
 }
 Temp[index][0] = Temp[0][0];
 Temp[index][1] = Temp[0][1];
 drawpoly(number, (int far *)Temp);
}

void World_Viewer(object_ptr poly, matrix_ptr TSig, int number)
{
 	int index;
   for (index=0;index<=number;index++)
   {
      Mat_Mul((vector_ptr)&poly->Point[index],TSig);
   }
}

void Viewer_Project(object_ptr poly, int number, int d)
{
  int index;
  for (index=0;index<=number;index++)
  {
  	poly->Point[index].p[X_COMP] =
   	poly->Point[index].p[X_COMP]*d/poly->Point[index].p[Z_COMP]+320.0;
  	poly->Point[index].p[Y_COMP] =(480-(
   	poly->Point[index].p[Y_COMP]*d/poly->Point[index].p[Z_COMP]+240.0));
  	poly->Point[index].p[Z_COMP] = d;

  }
}


// This Procedure Converts 2d Maps into 3d Fields with values set for
//field specified by POS X=0 Y=1 Z=2
void TwoD_ThreeD(object_ptr poly,int number,maptype_ptr mapname,float value,int Pos
,int horiz,int vert)
{
 int index;

 switch(Pos)
 {
 	case X_COMP:
   {
 	for (index=0;index<=number;index++)
	 {
 	 poly->Point[index].p[X_COMP] = value;
  	 poly->Point[index].p[Y_COMP] = (float)mapname->Vertex[index][X_COMP];
  	 poly->Point[index].p[Z_COMP] = (float)mapname->Vertex[index][Y_COMP];
    poly->Point[index].p[N_COMP] = 1.0;
 	};
   } break;
 	case Y_COMP:
   {
 	for (index=0;index<=number;index++)
 	{
 	 poly->Point[index].p[X_COMP]=horiz-((float)mapname->Vertex[index][X_COMP]);
  	 poly->Point[index].p[Y_COMP] = value;
  	 poly->Point[index].p[Z_COMP] = (float)mapname->Vertex[index][Y_COMP];
    poly->Point[index].p[N_COMP] = 1.0;
 	};
   } break;
 	case Z_COMP:
   {
 	for (index=0;index<=number;index++)
 	{
 	 poly->Point[index].p[X_COMP] =vert-((float)mapname->Vertex[index][Y_COMP]);
  	 poly->Point[index].p[Y_COMP] = (float)mapname->Vertex[index][X_COMP];
  	 poly->Point[index].p[Z_COMP] = value;
    poly->Point[index].p[N_COMP] = 1.0;
   };
   } break;
 } // End Switch

}

