class Input_Class
{
	public:
		const char *Input_File;
		Input_Class(const char *File);
		TFile Open_File();
		int Read_Line(TFile &, char *Temp);
};

// This is the Constructor
// ***************************************
Input_Class::Input_Class(const char *File)
{
 Input_File = File;
}

// This Opens a File And Returns the Handle..
TFile Input_Class::Open_File()
{
 TFile FName(Input_File, TFile::ReadOnly);
 return FName;
}


// This Function Takes the Input File and Returns in Temp
// A Pointer to a character array that contains a Single
// Line of the Input File w/ newline character.
// It Returns an Integer that is the Number of Characters
// in that line including the newline character.
// cBuffer is a 1 character array used as a buffer to
// Tell if end of line is reached.
//*******************************************************
int Input_Class::Read_Line(TFile &A_File,char *Temp)
{
	char cBuffer[1];
	char TempHold[80];
	int iCharNumber=0;
	BOOL bExit=FALSE;
	while ((iCharNumber < Line_Length) && (bExit == FALSE))
	{
	 A_File.Read(cBuffer,1);
	 if (cBuffer[0] == '\n' || cBuffer[0]== '\r')
		{
		bExit = TRUE;
		TempHold[iCharNumber] = 0;
		A_File.Read(cBuffer,1);
		}
	 else
		TempHold[iCharNumber] = cBuffer[0];
	 iCharNumber++;
	}
	iCharNumber=iCharNumber-1;
	strcpy(Temp,TempHold);
	return iCharNumber;
}

