#define B_Left 538
#define B_Right 730
#define B_Top   294
#define B_Bottom 506

class JTextUtils
{
	public:
		JTextUtils(int H,int V);
		~JTextUtils();
		void Set_Text(char *);
		void Set_Speed(int);
		void Set_HPos(int);
		void Set_VPos(int);
//		void Set_Params(int Speed, int H, int V, TColor*);
		void Set_Color(unsigned char,unsigned char,unsigned char); //RGB
		void Set_Color(TColor);
		void Set_ColorDir(int);
		void Set_AI(char *String,int index);
		void Set_JFont(int height, int width, char * name);
		void Set_JDC(TClientDC* JDevice);
		BOOL Scroll(int sx, int sy, BOOL Tab); // allows cutomizable direction and speed
		void Scroll(); // standard scroll 1 space X direction
		void Pulsate(BOOL PR,BOOL PG,BOOL PB,BOOL Show);
		BOOL AI_Interface();
		int 		 				scroll_speed;

	private:
		LOGFONT     			TheFont;
		TClientDC 				*winDC;
		TBitmap					*bck;
		char						JText[80];
		char 						AI_Msg[40][80];
		int 						AI_Clock;
		int 						AI_Intro;
		int 						AI_Line;
		int 						ALen[40];
		int 						APindex;
		int 						ALindex;
		BOOL						AI_Write;
		int 						AI_Fade;
		int 						TLen;
		int       				c_index;
		int       				horiz_pos;
		int 						h_init;
		int       				vert_pos;
		int						v_init;
		TColor    				Text_Color;
		TColor					JBlack;
		unsigned char       	VGreen;
		unsigned char 		 	VRed;
		unsigned char 		 	VBlue;
		int 						Color_Direction;
};


JTextUtils::JTextUtils(int H, int V)
{
	int i;
	JText[0] = 0;
	strcpy(JText,"Under MIDNIGHT - By: JEREMY C. WITT");
	for (i=0;i<40;i++)
		AI_Msg[i][0]=0;
	AI_Intro = 5;
	AI_Clock = 0;
	AI_Line = 0;
	AI_Fade=0;
	AI_Write=FALSE;
	strcpy(AI_Msg[0],"Testing AI INTERFACE");
	strcpy(AI_Msg[1],"Activate Neuronic Scan");
	strcpy(AI_Msg[2],"MAX Tolerance 80fm res.");
	strcpy(AI_Msg[3],"Automated Procedure Loaded");
	strcpy(AI_Msg[4],"Scanning............ EOL");
	strcpy(AI_Msg[5],"Bio-Degeneration Detected");
	strcpy(AI_Msg[6],"Cell Structure Mutated");
	strcpy(AI_Msg[7],"Analysis: Process Unavoidable");
	strcpy(AI_Msg[8],"Attempting Regeneration prc5");
	strcpy(AI_Msg[9],"Calculating..........................EOL");
	strcpy(AI_Msg[10],"Regeneration: Unsuccessful");
	strcpy(AI_Msg[11],"Subject is Terminal. EoF");
	for(i=0;i<40;i++)
		ALen[i] = strlen(AI_Msg[i]);
	APindex=0;
	ALindex=0;
	TLen = strlen(JText);
	if (H==-1)
		h_init=-(6*TLen);
	else
		h_init =H;
	horiz_pos = h_init;
	if (!V)
		v_init=0;
	else
		v_init=V;

	vert_pos = v_init;
	scroll_speed=1;
	Set_Color(0,255,0); //bright green
	JBlack = TColor(0,0,0);
	c_index = 0;
	VGreen = VRed = VBlue = 0;
	Color_Direction=3;
	TheFont.lfHeight = 12;
	TheFont.lfWidth = 6;
	TheFont.lfEscapement = 0;
	TheFont.lfOrientation;
	TheFont.lfWeight = FW_NORMAL;
	TheFont.lfItalic = 0;
	TheFont.lfUnderline = 0;
	TheFont.lfStrikeOut = 0;
	TheFont.lfCharSet = ANSI_CHARSET;
	TheFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
	TheFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	TheFont.lfQuality = PROOF_QUALITY;
	TheFont.lfPitchAndFamily = VARIABLE_PITCH|FF_DECORATIVE;
	strcpy(TheFont.lfFaceName, "Times New Roman");

}

JTextUtils::~JTextUtils()
{
 delete winDC;
}

void JTextUtils::Set_JDC(TClientDC* JDevice)
{
	winDC = JDevice;
	winDC->SetBkMode(TRANSPARENT);
  /*	TRect area;
	TBitmap *Dummy;
	TPoint P;
	P.x=0;
	P.y=0;
	Dummy = new TBitmap(*winDC,1,1);
	area.top = 0;
	area.left = 0;
	area.right =800;
	area.bottom=650;
  //	bck = new TBitmap(*winDC,800,650);
  //	TMemoryDC BACK(*winDC);
  //	BACK.SelectObject(*bck);
  //	BACK.MaskBlt(area,*Dummy,P,*Dummy,P,BLACKNESS); */

}

void JTextUtils::Pulsate(BOOL PR, BOOL PG, BOOL PB, BOOL Show)
{


	if(PR)
		VRed += (unsigned char) Color_Direction;
	if(PG)
		VGreen += (unsigned char) Color_Direction;
	if (PB)
		VBlue += (unsigned char) Color_Direction;
	if (PG&&(VGreen == 255 || VGreen == 0) ||
		 PR&&(VRed   == 255 || VRed   == 0) ||
		 PB&&(VBlue  == 255 || VBlue  == 0))
		Color_Direction = -Color_Direction;
	Set_Color(VRed,VGreen,VBlue);
	if(Show)
	{
		winDC->SaveDC();
		winDC->SetTextColor(Text_Color);
		TFont* font = new TFont(&TheFont); //Create Font
		winDC->SelectObject(*font);    		//Select Font
		winDC->TextOut(horiz_pos,vert_pos,JText,TLen);	//Output Text
		winDC->RestoreFont();
		winDC->RestoreDC();
		delete font;
	}
}


void JTextUtils::Scroll()
{
  TFont* font = new TFont(&TheFont);
  winDC->SaveDC();
  winDC->SelectObject(*font);
  winDC->SetTextColor(JBlack);
  winDC->TextOut(horiz_pos,vert_pos,JText,TLen);
  winDC->SetTextColor(Text_Color);
  horiz_pos += scroll_speed;
  if(horiz_pos > 800)
	horiz_pos =h_init;
  winDC->TextOut(horiz_pos,vert_pos,JText,TLen);
  winDC->RestoreFont();
  winDC->RestoreDC();
  delete font;
}

BOOL JTextUtils::Scroll(int sx, int sy, BOOL Tab)
{
  TFont* font = new TFont(&TheFont);
  TPoint Temp;
  winDC->SaveDC();
  winDC->SelectObject(*font);
  winDC->SetTextColor(JBlack);
  if (Tab)
  {
	Temp.x = horiz_pos;
	Temp.y = vert_pos;
	winDC->TabbedTextOut(Temp,JText,TLen,0,0,0);
  }
  else
	winDC->TextOut(horiz_pos,vert_pos,JText,TLen);
  winDC->SetTextColor(Text_Color);
  if(sx)
	horiz_pos += scroll_speed;
  if(sy)
	vert_pos += scroll_speed;
  if(horiz_pos > 800 || vert_pos < 0)
  {
	horiz_pos =h_init;
	vert_pos = 550;
	return 1;
  }
  if(Tab)
  {
		Temp.x = horiz_pos;
		Temp.y = vert_pos;
		winDC->TabbedTextOut(Temp,JText,TLen,0,0,0);
  }
  else
	  winDC->TextOut(horiz_pos,vert_pos,JText,TLen);
  winDC->RestoreFont();
  winDC->RestoreDC();
  delete font;
  return 0;
}

BOOL JTextUtils::AI_Interface()
{
 BOOL Fade_Done=FALSE;
 TPoint Temp;
 if(++AI_Clock > AI_Intro)
 {
	winDC->SaveDC();
	TFont* font = new TFont(&TheFont);
	winDC->SelectObject(*font);

	if (APindex==ALen[ALindex])
	{
		APindex = 0;
		ALindex++;
		vert_pos += 15;
		AI_Line=0;
	}
	if (ALindex==39)
	{
		ALindex=0;
		vert_pos = v_init;
		AI_Write=TRUE;
	}
	if (AI_Write)
	{
		if (++AI_Fade != 16)
		{

			VGreen = VGreen - 15;
			Set_Color(VRed,VGreen,VBlue);
			winDC->SetTextColor(Text_Color);
			for(int j =0; j<39; j++)
			{
				Temp.x = horiz_pos;
				Temp.y =15*j+vert_pos;
				winDC->TabbedTextOut(Temp,AI_Msg[j],ALen[j],0,0,0);
			}
		}
		else
		{
			AI_Write=FALSE;
			Fade_Done=TRUE;
			AI_Clock = 0;
			AI_Fade=0;
			VGreen=255;
			Set_Color(VRed,VGreen,VBlue);
		}
	}
	else
	{
		if (++AI_Line > 10)
		{
			winDC->SetTextColor(Text_Color);
			Temp.x = horiz_pos;
			Temp.y = vert_pos;
			winDC->TabbedTextOut(Temp,AI_Msg[ALindex],++APindex,0,0,0);
		}
	}
	winDC->RestoreFont();
	winDC->RestoreDC();
	delete font;
 }
 return Fade_Done;
}

void JTextUtils::Set_JFont(int height, int width, char * name)
{
 TheFont.lfHeight = height;
 TheFont.lfWidth  = width;
 strcpy(TheFont.lfFaceName, name);
}

void JTextUtils::Set_Text(char *thetext)
{
 strcpy(JText,thetext);
 TLen = strlen(JText);
}

void JTextUtils::Set_Speed(int NewSpeed)
{
 scroll_speed = NewSpeed;
}

void JTextUtils::Set_HPos(int H_pos)
{
	horiz_pos = H_pos;
}

void JTextUtils::Set_VPos(int V_pos)
{
	vert_pos = V_pos;
}

void JTextUtils::Set_Color(unsigned char SCR, unsigned char SCG,
									unsigned char SCB)
{
 Text_Color = TColor(SCR,SCG,SCB);
}

void JTextUtils::Set_Color(TColor InColor)
{
	Text_Color = InColor;
}

void JTextUtils::Set_ColorDir(int SCDirection)
{
	Color_Direction  = SCDirection;
}

void JTextUtils::Set_AI(char * String, int index)
{
	strcpy(AI_Msg[index],String);
	ALen[index] = strlen(String);
}


//********************************************************************
